searchNodes=[{"doc":"Serialize the given OpenApi spec module to a JSON file. Examples $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec apispec.json $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --pretty=true $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --check=true $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --start-app=false $ mix openapi.spec.json --spec PhoenixAppWeb.ApiSpec --vendor-extensions=false Command line options --spec - The ApiSpec module from which to generate the OpenAPI JSON file --pretty - Whether to prettify the generated JSON (defaults to false) --check - Whether to only compare the generated JSON with the spec file (defaults to false) --start-app - Whether need to start application before generate schema (defaults to true) --vendor-extensions - Whether to include open_api_spex OpenAPI vendor extensions (defaults to true) --quiet - Whether to disable output printing (defaults to false) --filename - The output filename (defaults to &quot;openapi.json&quot;)","ref":"Mix.Tasks.Openapi.Spec.Json.html","title":"Mix.Tasks.Openapi.Spec.Json","type":"task"},{"doc":"Serialize the given OpenApi spec module to a YAML file. Examples $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec apispec.yaml $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --check=true $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --start-app=false $ mix openapi.spec.yaml --spec PhoenixAppWeb.ApiSpec --vendor-extensions=false Command line options --spec - The ApiSpec module from which to generate the OpenAPI YAML file --check - Whether to only compare the generated YAML with the spec file (defaults to false) --start-app - Whether to start the application before generating the schema (defaults to true) --vendor-extensions - Whether to include open_api_spex OpenAPI vendor extensions (defaults to true) --quiet - Whether to disable output printing (defaults to false) --filename - The output filename (defaults to &quot;openapi.yaml&quot;)","ref":"Mix.Tasks.Openapi.Spec.Yaml.html","title":"Mix.Tasks.Openapi.Spec.Yaml","type":"task"},{"doc":"Provides the entry-points for defining schemas, validating and casting.","ref":"OpenApiSpex.html","title":"OpenApiSpex","type":"module"},{"doc":"","ref":"OpenApiSpex.html#add_parameter_content_parser/3","title":"OpenApiSpex.add_parameter_content_parser/3","type":"function"},{"doc":"Add more schemas to an existing OpenApi struct. This is useful when the schemas are not used by a Plug or Controller. Perhaps they're used by a Phoenix Channel. Example defmodule MyAppWeb.ApiSpec do def spec do % OpenApiSpex.OpenApi { # ... paths : OpenApiSpex.Paths . from_router ( MyAppWeb.Router ) # ... } |&gt; OpenApiSpex . resolve_schema_modules ( ) |&gt; OpenApiSpex . add_schemas ( [ MyAppWeb.Schemas.Message , MyAppWeb.Schemas.Channel ] ) end end","ref":"OpenApiSpex.html#add_schemas/2","title":"OpenApiSpex.add_schemas/2","type":"function"},{"doc":"Get casted body params from a Plug.Conn . If the conn has not been yet casted nil is returned.","ref":"OpenApiSpex.html#body_params/1","title":"OpenApiSpex.body_params/1","type":"function"},{"doc":"Build a Schema struct from the given keyword list. This function adds functionality over defining a schema with struct literal sytax using %OpenApiSpex.Struct{} : When the :module option is given, the :&quot;x-struct and :title attributes of the schema will be autopopulated based on the given module Validations are performed on the schema to ensure it is correct. Options :module (module) - A module in the application that the schema should be associated with.","ref":"OpenApiSpex.html#build_schema/2","title":"OpenApiSpex.build_schema/2","type":"function"},{"doc":"Cast params to conform to a OpenApiSpex.Schema . See OpenApiSpex.Schema.cast/3 for additional examples and details.","ref":"OpenApiSpex.html#cast/3","title":"OpenApiSpex.cast/3","type":"function"},{"doc":"Cast all params in Plug.Conn to conform to the schemas for OpenApiSpex.Operation . Returns {:ok, Plug.Conn.t} with params and body_params fields updated if successful, or {:error, reason} if casting fails. content_type may optionally be supplied to select the requestBody schema.","ref":"OpenApiSpex.html#cast/4","title":"OpenApiSpex.cast/4","type":"function"},{"doc":"","ref":"OpenApiSpex.html#cast_and_validate/5","title":"OpenApiSpex.cast_and_validate/5","type":"function"},{"doc":"Cast and validate a value against a given Schema.","ref":"OpenApiSpex.html#cast_value/2","title":"OpenApiSpex.cast_value/2","type":"function"},{"doc":"Cast and validate a value against a given Schema belonging to a given OpenApi spec.","ref":"OpenApiSpex.html#cast_value/4","title":"OpenApiSpex.cast_value/4","type":"function"},{"doc":"Raises compile time errors for improperly defined schemas.","ref":"OpenApiSpex.html#error!/3","title":"OpenApiSpex.error!/3","type":"function"},{"doc":"","ref":"OpenApiSpex.html#error_message/1","title":"OpenApiSpex.error_message/1","type":"function"},{"doc":"Get casted params from a Plug.Conn . If the conn has not been yet casted nil is returned.","ref":"OpenApiSpex.html#params/1","title":"OpenApiSpex.params/1","type":"function"},{"doc":"","ref":"OpenApiSpex.html#path_to_string/1","title":"OpenApiSpex.path_to_string/1","type":"function"},{"doc":"Resolve a schema or reference to a schema.","ref":"OpenApiSpex.html#resolve_schema/2","title":"OpenApiSpex.resolve_schema/2","type":"function"},{"doc":"Adds schemas to the api spec from the modules specified in the Operations. Eg, if the response schema for an operation is defined with: responses : %{ 200 =&gt; Operation . response ( &quot;User&quot; , &quot;application/json&quot; , UserResponse ) } Then the UserResponse.schema() function will be called to load the schema, and a Reference to the loaded schema will be used in the operation response. See OpenApiSpex.schema macro for a convenient syntax for defining schema modules.","ref":"OpenApiSpex.html#resolve_schema_modules/1","title":"OpenApiSpex.resolve_schema_modules/1","type":"function"},{"doc":"Declares a struct based OpenApiSpex.Schema defines the schema/0 callback ensures the schema is linked to the module by &quot;x-struct&quot; extension property defines a struct with keys matching the schema properties defines a @type t for the struct derives a Jason.Encoder and/or Poison.Encoder for the struct See OpenApiSpex.Schema for additional examples and details. Example require OpenApiSpex defmodule User do OpenApiSpex . schema %{ title : &quot;User&quot; , description : &quot;A user of the app&quot; , type : :object , properties : %{ id : % Schema { type : :integer , description : &quot;User ID&quot; } , name : % Schema { type : :string , description : &quot;User name&quot; , pattern : ~r/[a-zA-Z][a-zA-Z0-9_]+/ } , email : % Schema { type : :string , description : &quot;Email address&quot; , format : :email } , inserted_at : % Schema { type : :string , description : &quot;Creation timestamp&quot; , format : :&#39;date-time&#39; } , updated_at : % Schema { type : :string , description : &quot;Update timestamp&quot; , format : :&#39;date-time&#39; } } , required : [ :name , :email ] , example : %{ &quot;id&quot; =&gt; 123 , &quot;name&quot; =&gt; &quot;Joe User&quot; , &quot;email&quot; =&gt; &quot;joe@gmail.com&quot; , &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot; , &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } } end Example This example shows the :struct? and :derive? options that may be passed to schema/2 : defmodule MyAppWeb.Schemas.User do require OpenApiSpex alias OpenApiSpex.Schema OpenApiSpex . schema ( %{ type : :object , properties : %{ name : % Schema { type : :string } } } , struct? : false , derive? : false ) end Options :struct? (boolean) - When false, prevents the automatic generation of a struct definition for the schema module. :derive? (boolean) When false, prevents the automatic generation of a @derive call for either Poison.Encoder or Jason.Encoder . Using this option can prevent &quot;... protocol has already been consolidated ...&quot; compiler warnings.","ref":"OpenApiSpex.html#schema/2","title":"OpenApiSpex.schema/2","type":"macro"},{"doc":"Creates an %OpenApi{} struct from a map. This is useful when importing existing JSON or YAML encoded schemas. Example # Importing an existing JSON encoded schema open_api_spec_from_json = &quot;encoded_schema.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) |&gt; OpenApiSpex.OpenApi.Decode . decode ( ) # Importing an existing YAML encoded schema open_api_spec_from_yaml = &quot;encoded_schema.yaml&quot; |&gt; YamlElixir . read_all_from_file! ( ) |&gt; OpenApiSpex.OpenApi.Decode . decode ( )","ref":"OpenApiSpex.html#schema_from_map/1","title":"OpenApiSpex.schema_from_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.html#title_from_module/1","title":"OpenApiSpex.title_from_module/1","type":"function"},{"doc":"Validate params against OpenApiSpex.Schema . See OpenApiSpex.Schema.validate/3 for examples of error messages.","ref":"OpenApiSpex.html#validate/3","title":"OpenApiSpex.validate/3","type":"function"},{"doc":"Validate all params in Plug.Conn against OpenApiSpex.Operation parameter and requestBody schemas. content_type may be optionally supplied to select the requestBody schema.","ref":"OpenApiSpex.html#validate/4","title":"OpenApiSpex.validate/4","type":"function"},{"doc":"Validate the compiled schema's properties to ensure the schema is not improperly defined. Only errors which would cause a given schema to always fail should be raised here.","ref":"OpenApiSpex.html#validate_compiled_schema/1","title":"OpenApiSpex.validate_compiled_schema/1","type":"function"},{"doc":"Used for validating the schema at compile time, otherwise we're forced to raise errors for improperly defined schemas at runtime.","ref":"OpenApiSpex.html#validate_compiled_schema/2","title":"OpenApiSpex.validate_compiled_schema/2","type":"function"},{"doc":"","ref":"OpenApiSpex.html#t:cast_opt/0","title":"OpenApiSpex.cast_opt/0","type":"type"},{"doc":"","ref":"OpenApiSpex.html#t:read_write_scope/0","title":"OpenApiSpex.read_write_scope/0","type":"type"},{"doc":"Defines the OpenApiSpex.Callback.t type.","ref":"OpenApiSpex.Callback.html","title":"OpenApiSpex.Callback","type":"module"},{"doc":"Callback Object A map of possible out-of band callbacks related to the parent operation. Each value in the map is a Path Item Object that describes a set of requests that may be initiated by the API provider and the expected responses. The key value used to identify the callback object is an expression, evaluated at runtime, that identifies a URL to use for the callback operation.","ref":"OpenApiSpex.Callback.html#t:t/0","title":"OpenApiSpex.Callback.t/0","type":"type"},{"doc":"Cast and validate a value against an OpenApiSpex schema","ref":"OpenApiSpex.Cast.html","title":"OpenApiSpex.Cast","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.html#cast/1","title":"OpenApiSpex.Cast.cast/1","type":"function"},{"doc":"Cast and validate a value against the given schema. Recognizes all the types defined in Open API (itself a superset of JSON Schema). JSON Schema types: https://json-schema.org/latest/json-schema-core.html#rfc.section.4.2.1 Open API primitive types: https://github.com/OAI/OpenAPI-Specification/blob/master/versions/3.0.0.md#data-types For an :object schema type, the cast operation returns a map with atom keys. Examples iex&gt; alias OpenApiSpex . { Cast , Schema } iex&gt; schema = % Schema { type : :string } iex&gt; Cast . cast ( schema , &quot;a string&quot; ) { :ok , &quot;a string&quot; } iex&gt; Cast . cast ( schema , 1 .. 100 ) { :error , [ % OpenApiSpex.Cast.Error { reason : :invalid_type , type : :string , value : 1 .. 100 } ] } iex&gt; schema = % Schema { ...&gt; type : :object , ...&gt; properties : %{ ...&gt; name : nil ...&gt; } , ...&gt; additionalProperties : false ...&gt; } iex&gt; Cast . cast ( schema , %{ &quot;name&quot; =&gt; &quot;spex&quot; } ) { :ok , %{ name : &quot;spex&quot; } } iex&gt; Cast . cast ( schema , %{ &quot;bad&quot; =&gt; &quot;spex&quot; } ) { :error , [ % OpenApiSpex.Cast.Error { name : &quot;bad&quot; , path : [ &quot;bad&quot; ] , reason : :unexpected_field , value : %{ &quot;bad&quot; =&gt; &quot;spex&quot; } } ] }","ref":"OpenApiSpex.Cast.html#cast/4","title":"OpenApiSpex.Cast.cast/4","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#error/2","title":"OpenApiSpex.Cast.error/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#ok/1","title":"OpenApiSpex.Cast.ok/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#success/2","title":"OpenApiSpex.Cast.success/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:cast_opt/0","title":"OpenApiSpex.Cast.cast_opt/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:read_write_scope/0","title":"OpenApiSpex.Cast.read_write_scope/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:schema_or_reference/0","title":"OpenApiSpex.Cast.schema_or_reference/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.html#t:t/0","title":"OpenApiSpex.Cast.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Discriminator.t type.","ref":"OpenApiSpex.Cast.Discriminator.html","title":"OpenApiSpex.Cast.Discriminator","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.Discriminator.html#cast/1","title":"OpenApiSpex.Cast.Discriminator.cast/1","type":"function"},{"doc":"Discriminator Object When request bodies or response payloads may be one of a number of different schemas, a discriminator object can be used to aid in serialization, deserialization, and validation. The discriminator is a specific object in a schema which is used to inform the consumer of the specification of an alternative schema based on the value associated with it. A discriminator requires a composite key be set on the schema: allOf oneOf anyOf","ref":"OpenApiSpex.Cast.Discriminator.html#t:t/0","title":"OpenApiSpex.Cast.Discriminator.t/0","type":"type"},{"doc":"OpenApiSpex Cast Error","ref":"OpenApiSpex.Cast.Error.html","title":"OpenApiSpex.Cast.Error","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#message/1","title":"OpenApiSpex.Cast.Error.message/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#message_with_path/1","title":"OpenApiSpex.Cast.Error.message_with_path/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#new/2","title":"OpenApiSpex.Cast.Error.new/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#path_to_string/1","title":"OpenApiSpex.Cast.Error.path_to_string/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:all_of_error/0","title":"OpenApiSpex.Cast.Error.all_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:any_of_error/0","title":"OpenApiSpex.Cast.Error.any_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:args/0","title":"OpenApiSpex.Cast.Error.args/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:custom_error/0","title":"OpenApiSpex.Cast.Error.custom_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:exclusive_max_error/0","title":"OpenApiSpex.Cast.Error.exclusive_max_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:exclusive_min_error/0","title":"OpenApiSpex.Cast.Error.exclusive_min_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_discriminator_value_error/0","title":"OpenApiSpex.Cast.Error.invalid_discriminator_value_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_enum_error/0","title":"OpenApiSpex.Cast.Error.invalid_enum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_format_error/0","title":"OpenApiSpex.Cast.Error.invalid_format_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_header_error/0","title":"OpenApiSpex.Cast.Error.invalid_header_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_schema_error/0","title":"OpenApiSpex.Cast.Error.invalid_schema_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:invalid_type_error/0","title":"OpenApiSpex.Cast.Error.invalid_type_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_items_error/0","title":"OpenApiSpex.Cast.Error.max_items_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_length_error/0","title":"OpenApiSpex.Cast.Error.max_length_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:max_properties_error/0","title":"OpenApiSpex.Cast.Error.max_properties_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:maximum_error/0","title":"OpenApiSpex.Cast.Error.maximum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_items_error/0","title":"OpenApiSpex.Cast.Error.min_items_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_length_error/0","title":"OpenApiSpex.Cast.Error.min_length_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:min_properties_error/0","title":"OpenApiSpex.Cast.Error.min_properties_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:minimum_error/0","title":"OpenApiSpex.Cast.Error.minimum_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:missing_field_error/0","title":"OpenApiSpex.Cast.Error.missing_field_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:missing_header_error/0","title":"OpenApiSpex.Cast.Error.missing_header_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:multiple_of_error/0","title":"OpenApiSpex.Cast.Error.multiple_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:no_value_for_discriminator_error/0","title":"OpenApiSpex.Cast.Error.no_value_for_discriminator_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:null_value_error/0","title":"OpenApiSpex.Cast.Error.null_value_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:one_of_error/0","title":"OpenApiSpex.Cast.Error.one_of_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:reason/0","title":"OpenApiSpex.Cast.Error.reason/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:t/0","title":"OpenApiSpex.Cast.Error.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:unexpected_field_error/0","title":"OpenApiSpex.Cast.Error.unexpected_field_error/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Cast.Error.html#t:unique_items_error/0","title":"OpenApiSpex.Cast.Error.unique_items_error/0","type":"type"},{"doc":"This module will cast a binary to either an Elixir DateTime or Date. Otherwise it will validate a binary based on maxLength, minLength, or a Regex pattern passed through the schema struct.","ref":"OpenApiSpex.Cast.String.html","title":"OpenApiSpex.Cast.String","type":"module"},{"doc":"","ref":"OpenApiSpex.Cast.String.html#cast/1","title":"OpenApiSpex.Cast.String.cast/1","type":"function"},{"doc":"Defines the OpenApiSpex.Components.t type.","ref":"OpenApiSpex.Components.html","title":"OpenApiSpex.Components","type":"module"},{"doc":"","ref":"OpenApiSpex.Components.html#t:responses_map/0","title":"OpenApiSpex.Components.responses_map/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Components.html#t:schemas_map/0","title":"OpenApiSpex.Components.schemas_map/0","type":"type"},{"doc":"Components Object Holds a set of reusable objects for different aspects of the OAS. All objects defined within the components object will have no effect on the API unless they are explicitly referenced from properties outside the components object.","ref":"OpenApiSpex.Components.html#t:t/0","title":"OpenApiSpex.Components.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Contact.t type.","ref":"OpenApiSpex.Contact.html","title":"OpenApiSpex.Contact","type":"module"},{"doc":"Contact Object Contact information for the exposed API.","ref":"OpenApiSpex.Contact.html#t:t/0","title":"OpenApiSpex.Contact.t/0","type":"type"},{"doc":"Generation of OpenAPI documentation via ExDoc documentation and tags. Note: For projects using Elixir releases, there is an issue that potentially breaks OpenApiSpex's integration with your application. Please use OpenApiSpex.ControllerSpecs instead. Supported OpenAPI fields description and summary Description of endpoint will be filled with documentation string in the same manner as ExDocs, so first line will be used as a summary and the rest of it will be used as description field. operation_id The action's operation_id can be set explicitly using a @doc tag. If no operation_id is specified, it will default to the action's module path: Module.Name.function_name parameters Parameters of the endpoint are defined by :parameters tag which should be map or list that is formed as: [ param_name : definition ] # or [ structure_definition ] Where definition is map or keyword list that accepts the same arguments. Where structure_definition is OpenApiSpex.Parameter.t() or OpenApiSpex.Reference.t() structure that accepts the same arguments. Example: @doc parameters : [ group_id : [ in : :path , type : :integer , description : &quot;Group ID&quot; , example : 1 ] ] or @doc parameters : [ % OpenApiSpex.Parameter { in : :path , name : :group_id , description : &quot;Group ID&quot; , schema : % Schema { type : :integer } , required : true , example : 1 } ] or @doc parameters : [ &quot;$ref&quot; : &quot;#/components/parameters/group_id&quot; # or % OpenApiSpex.Reference { &quot;$ref&quot; : &quot;#/components/parameters/group_id&quot; } ] responses Responses are controlled by :responses tag. Responses must be defined as a map or keyword list in form of: %{ 200 =&gt; { &quot;Response name&quot; , &quot;application/json&quot; , schema } , :not_found =&gt; { &quot;Response name&quot; , &quot;application/json&quot; , schema } } Or: [ ok : { &quot;Response name&quot; , &quot;application/json&quot; , schema } , not_found : { &quot;Response name&quot; , &quot;application/json&quot; , schema } ] If a response has no body, the definition may be simplified further: [ no_content : &quot;Empty response&quot; ] For each key in the key-value list of map, either an HTTP status code can be used or its atom equivalent. The full set of atom keys are defined in Plug.Conn.Status.code/1 . requestBody Controlled by :request_body parameter and is defined as a tuple in form {description, mime, schema} or {description, mime, schema, opts} that matches the arguments of OpenApiSpex.Operation.request_body/3 or OpenApiSpex.Operation.request_body/4 , respectively. @doc request_body : { &quot;CartUpdateRequest&quot; , &quot;application/vnd.api+json&quot; , CartUpdateRequest , required : true } security Allows specifying the security scheme(s) required for this operation. See OpenApiSpex.Operation and OpenApiSpex.SecurityRequirement . tags Tags are controlled by :tags attribute. In contrast to other attributes, this one will also inherit all tags defined as a module documentation attributes. Example defmodule UserController do @moduledoc tags : [ &quot;Users&quot; ] use MyAppWeb , :controller use OpenApiSpex.Controller @doc &quot;&quot;&quot; Endpoint summary Endpoint description... &quot;&quot;&quot; @doc parameters : [ id : [ in : :path , type : :string , required : true ] ] , request_body : { &quot;Request body to update User&quot; , &quot;application/json&quot; , UserUpdateBody , required : true } , responses : [ ok : { &quot;User document&quot; , &quot;application/json&quot; , UserSchema } , { 302 , &quot;Redirect&quot; , &quot;text/html&quot; , EmptyResponse , headers : %{ &quot;Location&quot; =&gt; % Header { description : &quot;Redirect Location&quot; } } } ] def update ( conn , %{ id : id } ) do user_params = conn . body_params # … end end","ref":"OpenApiSpex.Controller.html","title":"OpenApiSpex.Controller","type":"module"},{"doc":"Macros for defining operation specs, shared operation tags, and shared security specs in a Phoenix controller. Example Here is an example Phoenix controller that uses the ControllerSpecs Operation specs: defmodule MyAppWeb.UserController do use Phoenix.Controller use OpenApiSpex.ControllerSpecs alias MyAppWeb.Schemas . { UserParams , UserResponse } tags [ &quot;users&quot; ] security [ %{ } , %{ &quot;petstore_auth&quot; =&gt; [ &quot;write:users&quot; , &quot;read:users&quot; ] } ] operation :update , summary : &quot;Update user&quot; , parameters : [ id : [ in : :path , description : &quot;User ID&quot; , type : :integer , example : 1001 ] ] , request_body : { &quot;User params&quot; , &quot;application/json&quot; , UserParams } , responses : [ ok : { &quot;User response&quot; , &quot;application/json&quot; , UserResponse } ] def update ( conn , %{ &quot;id&quot; =&gt; id } ) do json ( conn , %{ data : %{ id : id , name : &quot;joe user&quot; , email : &quot;joe@gmail.com&quot; } } ) end end If you use Elixir Formatter, :open_api_spex can be added to the :import_deps list in the .formatter.exs file of your project to make parentheses of the macros optional. .formatter.exs : [ import_deps : [ :open_api_spex ] ] parameters parameters is a keyword list (or map) of request parameters (not body parameters). They each represent the OpenAPI Parameter Object . There is a convenient shortcut :type for base data types supported by open api parameters : [ id : [ in : :query , type : :integer , required : true , description : &quot;User ID&quot; , example : 1001 ] ] This is equivalent to: parameters : [ id : [ in : :query , schema : % OpenApiSpex.Schema { type : :integer } , required : true , description : &quot;User ID&quot; , example : 1001 ] ] The keyword value is the parameter name. Each value in the keyword list correlates to a field in the OpenAPI ParameterObject. request_body The request_body defines the OpenAPI RequestBodyObject . The request_body takes a tuple that is 2-4 elements in length. The elements of the tuple are: The RequestBody description field. The RequestBody content field, consisting of a mapping of content types to their MediaType objects, or a simple content type string (e.g., &quot;application/json&quot;). content : &quot;application/json&quot; Or: content : %{ &quot;application/text&quot; =&gt; [ example : &quot;some text!&quot; ] } Or: content : %{ &quot;application/text&quot; =&gt; [ % OpenApiSpex.MediaType { example : &quot;some text!&quot; } ] } The default schema of the RequestBody. A keyword list of options. responses The responses key defines the OpenAPI Responses Object The responses value is a keyword list or map that maps the HTTP status to a ResponseObject . If the the responses is defined using keyword list syntax, the HTTP status codes can be replaced with their text equivalents: responses : [ ok : { &quot;User response&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.UserResponse } , unprocessable_entity : { &quot;Bad request parameters&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.BadRequestParameters } , not_found : { &quot;Not found&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.NotFound } ] The full set of atom keys are defined in Plug.Conn.Status.code/1 . Alternately, the HTTP status codes can be specified directly: responses : %{ 200 =&gt; { &quot;User response&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.UserResponse } , 422 =&gt; { &quot;Bad request parameters&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.BadRequestParameters } , 404 =&gt; { &quot;Not found&quot; , &quot;application/json&quot; , MyAppWeb.Schemas.NotFound } } The ResponseObject is represented as a tuple that is 2-4 elements in length. The elements of the tuple are: The ResponseObject description field. The ResponseObject content field, consisting of a mapping of content types to their MediaType objects, or a simple content type string (e.g., &quot;application/json&quot;). content : %{ &quot;application/json&quot; =&gt; [ example : &quot;{[]}&quot; ] } Or: content : &quot;application/json&quot; The default schema of the response body. A keyword list of options to add to the OpenApiSpex.Response or OpenApiSpex.MediaType structs that are generated.","ref":"OpenApiSpex.ControllerSpecs.html","title":"OpenApiSpex.ControllerSpecs","type":"module"},{"doc":"Defines an Operation spec for a controller action. Example operation :update , summary : &quot;Update user&quot; , description : &quot;Updates a user record from the given ID path parameter and request body parameters.&quot; , parameters : [ id : [ in : :path , description : &quot;User ID&quot; , type : :integer , example : 1001 ] ] , request_body : { &quot;User params&quot; , &quot;application/json&quot; , UserParams } , responses : [ ok : { &quot;User response&quot; , &quot;application/json&quot; , UserResponse } ] , security : [ %{ } , %{ &quot;petstore_auth&quot; =&gt; [ &quot;write:pets&quot; , &quot;read:pets&quot; ] } ] , tags : [ &quot;users&quot; ] Options These options correlate to the Operation fields specified in the Open API spec . One difference however, is that the fields defined in Open API use camelCase naming, while the fields used in ControllerSpecs use snake_case to match Elixir's convention. summary The operation summary parameters The endpoint's parameters. The syntax for parameters can take multiple forms: The common form is a keyword list, where each key is the parameter name, and the value is a keyword list of options that correlate to the fields in an Open API Parameter Object . For example: parameters : [ id : [ in : :path , description : &quot;User ID&quot; , type : :integer , example : 1001 ] ] A parameters list can also contain references to parameter schemas. There are two ways to do that: parameters : [ &quot;$ref&quot; : &quot;#/components/parameters/user_id&quot; # or % OpenApiSpex.Reference { &quot;$ref&quot; : &quot;#/components/parameters/user_id&quot; } ] request_body The endpoint's request body. There are multiple ways to specify a request body: A three or four-element tuple: request_body : { &quot;User update request body&quot; , &quot;application/json&quot; , UserUpdateRequest , required : true } The tuple consists of the following: The description The content-type An Open API schema. This can be a schema module that implements the OpenApiSpex.Schema behaviour , or an OpenApiSpex.Schema struct. A optional keyword list of options. There is only one option available, and that is required: boolean . responses The endpoint's responses, for each HTTP status code the endpoint may respond with. Multiple syntaxes are supported: A common syntax is a keyword list, where each key is the textual name of an HTTP status code. For example: [ ok : { &quot;User response&quot; , &quot;application/json&quot; , User } , not_found : { &quot;User not found&quot; , &quot;application/json&quot; , NotFound } ] The list of names and their code mappings is defined in Plug.Conn.Status.code/1 . If a map is used, the keys can either be the same atom keys used in the keyword syntax ( %{ok: ...} ), or they can be integers representing the HTTP status code directly: responses : %{ 200 =&gt; { &quot;User response&quot; , &quot;application/json&quot; , User } , 404 =&gt; { &quot;User not found&quot; , &quot;application/json&quot; , NotFound } } Each response can be a three-element tuple: responses : [ ok : { &quot;User response&quot; , &quot;application/json&quot; , User } # Or ok : { &quot;User response&quot; , &quot;application/json&quot; , % OpenApiSpex.Schema { ... } } ] This tuple consists of: A Description string A content-type string An Open API schema. This can be a schema module that implements the OpenApiSpex.Schema behaviour , or an OpenApiSpex.Schema struct. An optional Keyword list with the following optional key/values: a. example: an example string b. examples: a list of example strings c. headers: a Map with string keys defining the header name and an OpenApiSpex.Header struct as a value. If the response represents an empty response, the definition value can be a single string representing the response description. For example: responses : [ no_content : &quot;Empty response&quot; ] A response can also be defined as an OpenApiSpex.RequestBody struct. In fact, all response body syntaxes resolve to this struct. Additional fields: There are other Operation fields that can be specified that are not described here. See OpenApiSpex.Operation for all the fields.","ref":"OpenApiSpex.ControllerSpecs.html#operation/2","title":"OpenApiSpex.ControllerSpecs.operation/2","type":"macro"},{"doc":"Define an Operation for a controller action. See OpenApiSpex.ControllerSpecs for usage and examples.","ref":"OpenApiSpex.ControllerSpecs.html#operation_spec/3","title":"OpenApiSpex.ControllerSpecs.operation_spec/3","type":"function"},{"doc":"Defines security requirements shared by all operations defined in a controller. See Security Requirement Object spec and OpenApiSpex.SecurityRequirement for more information.","ref":"OpenApiSpex.ControllerSpecs.html#security/1","title":"OpenApiSpex.ControllerSpecs.security/1","type":"macro"},{"doc":"Defines a list of tags that all operations in a controller will share. Example tags [ &quot;users&quot; ] All operations defined in the controller will inherit the tags specified by this call. If an operation defines its own tags, the tags in this call will be appended to the operation's tags.","ref":"OpenApiSpex.ControllerSpecs.html#tags/1","title":"OpenApiSpex.ControllerSpecs.tags/1","type":"macro"},{"doc":"This module is deprecated. Please use OpenApiSpex.Cast instead.","ref":"OpenApiSpex.DeprecatedCast.html","title":"OpenApiSpex.DeprecatedCast","type":"module"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#cast/3","title":"OpenApiSpex.DeprecatedCast.cast/3","type":"function"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#validate/3","title":"OpenApiSpex.DeprecatedCast.validate/3","type":"function"},{"doc":"","ref":"OpenApiSpex.DeprecatedCast.html#validate/4","title":"OpenApiSpex.DeprecatedCast.validate/4","type":"function"},{"doc":"Defines the OpenApiSpex.Discriminator.t type.","ref":"OpenApiSpex.Discriminator.html","title":"OpenApiSpex.Discriminator","type":"module"},{"doc":"Resolve the schema that should be used to cast/validate a value using a Discriminator .","ref":"OpenApiSpex.Discriminator.html#resolve/3","title":"OpenApiSpex.Discriminator.resolve/3","type":"function"},{"doc":"Discriminator Object When request bodies or response payloads may be one of a number of different schemas, a discriminator object can be used to aid in serialization, deserialization, and validation. The discriminator is a specific object in a schema which is used to inform the consumer of the specification of an alternative schema based on the value associated with it.","ref":"OpenApiSpex.Discriminator.html#t:t/0","title":"OpenApiSpex.Discriminator.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Encoding.t type.","ref":"OpenApiSpex.Encoding.html","title":"OpenApiSpex.Encoding","type":"module"},{"doc":"Encoding Object A single encoding definition applied to a single schema property.","ref":"OpenApiSpex.Encoding.html#t:t/0","title":"OpenApiSpex.Encoding.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Example.t type.","ref":"OpenApiSpex.Example.html","title":"OpenApiSpex.Example","type":"module"},{"doc":"Example Object In all cases, the example value is expected to be compatible with the type schema of its associated value.","ref":"OpenApiSpex.Example.html#t:t/0","title":"OpenApiSpex.Example.t/0","type":"type"},{"doc":"Export spec in specified encoding","ref":"OpenApiSpex.ExportSpec.html","title":"OpenApiSpex.ExportSpec","type":"module"},{"doc":"","ref":"OpenApiSpex.ExportSpec.html#call/3","title":"OpenApiSpex.ExportSpec.call/3","type":"function"},{"doc":"","ref":"OpenApiSpex.Extendable.html","title":"OpenApiSpex.Extendable","type":"protocol"},{"doc":"","ref":"OpenApiSpex.Extendable.html#to_map/1","title":"OpenApiSpex.Extendable.to_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Extendable.html#t:t/0","title":"OpenApiSpex.Extendable.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.ExternalDocumentation.t type.","ref":"OpenApiSpex.ExternalDocumentation.html","title":"OpenApiSpex.ExternalDocumentation","type":"module"},{"doc":"External Documentation Object Allows referencing an external resource for extended documentation.","ref":"OpenApiSpex.ExternalDocumentation.html#t:t/0","title":"OpenApiSpex.ExternalDocumentation.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Header.t type.","ref":"OpenApiSpex.Header.html","title":"OpenApiSpex.Header","type":"module"},{"doc":"Header Object The Header Object follows the structure of the Parameter Object with the following changes: name MUST NOT be specified, it is given in the corresponding headers map. in MUST NOT be specified, it is implicitly in header. All traits that are affected by the location MUST be applicable to a location of header (for example, style).","ref":"OpenApiSpex.Header.html#t:t/0","title":"OpenApiSpex.Header.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Info.t type.","ref":"OpenApiSpex.Info.html","title":"OpenApiSpex.Info","type":"module"},{"doc":"Info Object The object provides metadata about the API. The metadata MAY be used by the clients if needed, and MAY be presented in editing or documentation generation tools for convenience.","ref":"OpenApiSpex.Info.html#t:t/0","title":"OpenApiSpex.Info.t/0","type":"type"},{"doc":"Schema for the default error renderer used by OpenApiSpex.Plug.CastAndValidate . Examples @doc responses : %{ 201 =&gt; { &quot;User&quot; , &quot;application/json&quot; , UserResponse } 422 =&gt; { &quot;Unprocessable Entity&quot; , &quot;application/json&quot; , OpenApiSpex.JsonErrorResponse } }","ref":"OpenApiSpex.JsonErrorResponse.html","title":"OpenApiSpex.JsonErrorResponse","type":"module"},{"doc":"Convenience function to return that wraps JsonErrorResponse in an Operation response. Examples @doc responses : %{ 201 =&gt; { &quot;User&quot; , &quot;application/json&quot; , UserResponse } 422 =&gt; OpenApiSpex.JsonErrorResponse . response ( ) }","ref":"OpenApiSpex.JsonErrorResponse.html#response/0","title":"OpenApiSpex.JsonErrorResponse.response/0","type":"function"},{"doc":"Callback implementation for OpenApiSpex.Schema.schema/0 .","ref":"OpenApiSpex.JsonErrorResponse.html#schema/0","title":"OpenApiSpex.JsonErrorResponse.schema/0","type":"function"},{"doc":"","ref":"OpenApiSpex.JsonErrorResponse.html#t:t/0","title":"OpenApiSpex.JsonErrorResponse.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.License.t type.","ref":"OpenApiSpex.License.html","title":"OpenApiSpex.License","type":"module"},{"doc":"License Object License information for the exposed API.","ref":"OpenApiSpex.License.html#t:t/0","title":"OpenApiSpex.License.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Link.t type.","ref":"OpenApiSpex.Link.html","title":"OpenApiSpex.Link","type":"module"},{"doc":"Link Object The Link object represents a possible design-time link for a response. The presence of a link does not guarantee the caller's ability to successfully invoke it, rather it provides a known relationship and traversal mechanism between responses and other operations. Unlike dynamic links (i.e. links provided in the response payload), the OAS linking mechanism does not require link information in the runtime response. For computing links, and providing instructions to execute them, a runtime expression is used for accessing values in an operation and using them as parameters while invoking the linked operation.","ref":"OpenApiSpex.Link.html#t:t/0","title":"OpenApiSpex.Link.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.MediaType.t type.","ref":"OpenApiSpex.MediaType.html","title":"OpenApiSpex.MediaType","type":"module"},{"doc":"Media Type Object Each Media Type Object provides schema and examples for the media type identified by its key.","ref":"OpenApiSpex.MediaType.html#t:t/0","title":"OpenApiSpex.MediaType.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.OAuthFlow.t type.","ref":"OpenApiSpex.OAuthFlow.html","title":"OpenApiSpex.OAuthFlow","type":"module"},{"doc":"OAuth Flow Object Configuration details for a supported OAuth Flow","ref":"OpenApiSpex.OAuthFlow.html#t:t/0","title":"OpenApiSpex.OAuthFlow.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.OAuthFlows.t type.","ref":"OpenApiSpex.OAuthFlows.html","title":"OpenApiSpex.OAuthFlows","type":"module"},{"doc":"OAuth Flows Object Allows configuration of the supported OAuth Flows.","ref":"OpenApiSpex.OAuthFlows.html#t:t/0","title":"OpenApiSpex.OAuthFlows.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.OpenApi.t type and the behaviour for application modules that construct an OpenApiSpex.OpenApi.t at runtime.","ref":"OpenApiSpex.OpenApi.html","title":"OpenApiSpex.OpenApi","type":"behaviour"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#from_map/1","title":"OpenApiSpex.OpenApi.from_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#json_encoder/0","title":"OpenApiSpex.OpenApi.json_encoder/0","type":"function"},{"doc":"A spec/0 callback function is required for use with the OpenApiSpex.Plug.PutApiSpec plug. Example @impl OpenApiSpex.OpenApi def spec do % OpenApi { servers : [ # Populate the Server info from a phoenix endpoint Server . from_endpoint ( MyAppWeb.Endpoint ) ] , info : % Info { title : &quot;My App&quot; , version : &quot;1.0&quot; } , # populate the paths from a phoenix router paths : Paths . from_router ( MyAppWeb.Router ) } |&gt; OpenApiSpex . resolve_schema_modules ( ) # discover request/response schemas from path specs end","ref":"OpenApiSpex.OpenApi.html#c:spec/0","title":"OpenApiSpex.OpenApi.spec/0","type":"callback"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#to_map/1","title":"OpenApiSpex.OpenApi.to_map/1","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#to_map/2","title":"OpenApiSpex.OpenApi.to_map/2","type":"function"},{"doc":"","ref":"OpenApiSpex.OpenApi.html#yaml_encoder/0","title":"OpenApiSpex.OpenApi.yaml_encoder/0","type":"function"},{"doc":"OpenAPI Object This is the root document object of the OpenAPI document.","ref":"OpenApiSpex.OpenApi.html#t:t/0","title":"OpenApiSpex.OpenApi.t/0","type":"type"},{"doc":"This module exposes functionality to convert an arbitrary map into a OpenApi struct.","ref":"OpenApiSpex.OpenApi.Decode.html","title":"OpenApiSpex.OpenApi.Decode","type":"module"},{"doc":"","ref":"OpenApiSpex.OpenApi.Decode.html#decode/1","title":"OpenApiSpex.OpenApi.Decode.decode/1","type":"function"},{"doc":"Defines the OpenApiSpex.Operation.t type.","ref":"OpenApiSpex.Operation.html","title":"OpenApiSpex.Operation","type":"module"},{"doc":"Cast params to the types defined by the schemas of the operation parameters and requestBody","ref":"OpenApiSpex.Operation.html#cast/4","title":"OpenApiSpex.Operation.cast/4","type":"function"},{"doc":"Constructs an Operation struct from plug module and opts","ref":"OpenApiSpex.Operation.html#from_plug/2","title":"OpenApiSpex.Operation.from_plug/2","type":"function"},{"doc":"Constructs an Operation struct from the plug and opts specified in the given route","ref":"OpenApiSpex.Operation.html#from_route/1","title":"OpenApiSpex.Operation.from_route/1","type":"function"},{"doc":"Shorthand for constructing an OpenApiSpex.Parameter given name, location, type, description and optional examples Examples iex&gt; Operation . parameter ( ...&gt; :status , ...&gt; :query , ...&gt; % OpenApiSpex.Schema { type : :string , enum : [ &quot;pending&quot; , &quot;in_progress&quot; , &quot;completed&quot; ] } , ...&gt; &quot;The status of an entity&quot; ...&gt; ) % OpenApiSpex.Parameter { name : :status , in : :query , description : &quot;The status of an entity&quot; , required : false , schema : % OpenApiSpex.Schema { enum : [ &quot;pending&quot; , &quot;in_progress&quot; , &quot;completed&quot; ] , type : :string } }","ref":"OpenApiSpex.Operation.html#parameter/5","title":"OpenApiSpex.Operation.parameter/5","type":"function"},{"doc":"Shorthand for constructing a RequestBody with description, media_type, schema and optional examples","ref":"OpenApiSpex.Operation.html#request_body/4","title":"OpenApiSpex.Operation.request_body/4","type":"function"},{"doc":"Shorthand for constructing a Response with description, media_type, schema and optional headers or examples","ref":"OpenApiSpex.Operation.html#response/4","title":"OpenApiSpex.Operation.response/4","type":"function"},{"doc":"Validate params against the schemas of the operation parameters and requestBody","ref":"OpenApiSpex.Operation.html#validate/4","title":"OpenApiSpex.Operation.validate/4","type":"function"},{"doc":"Operation Object Describes a single API operation on a path.","ref":"OpenApiSpex.Operation.html#t:t/0","title":"OpenApiSpex.Operation.t/0","type":"type"},{"doc":"Casts and validates a request from a Plug conn.","ref":"OpenApiSpex.Operation2.html","title":"OpenApiSpex.Operation2","type":"module"},{"doc":"","ref":"OpenApiSpex.Operation2.html#cast/5","title":"OpenApiSpex.Operation2.cast/5","type":"function"},{"doc":"Defines the OpenApiSpex.Parameter.t type.","ref":"OpenApiSpex.Parameter.html","title":"OpenApiSpex.Parameter","type":"module"},{"doc":"Gets the media type for a parameter, if not present nil is returned.","ref":"OpenApiSpex.Parameter.html#media_type/1","title":"OpenApiSpex.Parameter.media_type/1","type":"function"},{"doc":"Sets the schema for a parameter from a simple type, reference or Schema","ref":"OpenApiSpex.Parameter.html#put_schema/2","title":"OpenApiSpex.Parameter.put_schema/2","type":"function"},{"doc":"Gets the schema for a parameter, from the schema key or content key, which ever is populated.","ref":"OpenApiSpex.Parameter.html#schema/1","title":"OpenApiSpex.Parameter.schema/1","type":"function"},{"doc":"Valid values for the in key in the OpenApiSpex.Parameter struct.","ref":"OpenApiSpex.Parameter.html#t:location/0","title":"OpenApiSpex.Parameter.location/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Parameter.html#t:parameters/0","title":"OpenApiSpex.Parameter.parameters/0","type":"type"},{"doc":"Valid values for the style key in the OpenApiSpex.Parameter struct.","ref":"OpenApiSpex.Parameter.html#t:style/0","title":"OpenApiSpex.Parameter.style/0","type":"type"},{"doc":"Parameter Object Describes a single operation parameter. A unique parameter is defined by a combination of a name and location. Parameter Locations There are four possible parameter locations specified by the in field: path: Used together with Path Templating, where the parameter value is actually part of the operation's URL. This does not include the host or base path of the API. For example, in /items/{itemId} , the path parameter is itemId. query: Parameters that are appended to the URL. For example, in /items?id=### , the query parameter is id. header: Custom headers that are expected as part of the request. Note that RFC7230 states header names are case insensitive. cookie: Used to pass a specific cookie value to the API.","ref":"OpenApiSpex.Parameter.html#t:t/0","title":"OpenApiSpex.Parameter.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Parameter.html#t:type/0","title":"OpenApiSpex.Parameter.type/0","type":"type"},{"doc":"Defines the OpenApiSpex.PathItem.t type.","ref":"OpenApiSpex.PathItem.html","title":"OpenApiSpex.PathItem","type":"module"},{"doc":"Builds a PathItem struct from a list of routes that share a path.","ref":"OpenApiSpex.PathItem.html#from_routes/1","title":"OpenApiSpex.PathItem.from_routes/1","type":"function"},{"doc":"Represents a route from in a Plug/Phoenix application. Eg from the generated __routes__ function in a Phoenix.Router module.","ref":"OpenApiSpex.PathItem.html#t:route/0","title":"OpenApiSpex.PathItem.route/0","type":"type"},{"doc":"Path Item Object Describes the operations available on a single path. A Path Item MAY be empty, due to ACL constraints. The path itself is still exposed to the documentation viewer but they will not know which operations and parameters are available.","ref":"OpenApiSpex.PathItem.html#t:t/0","title":"OpenApiSpex.PathItem.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Paths.t type.","ref":"OpenApiSpex.Paths.html","title":"OpenApiSpex.Paths","type":"module"},{"doc":"Create a Paths map from the routes in the given router module.","ref":"OpenApiSpex.Paths.html#from_router/1","title":"OpenApiSpex.Paths.from_router/1","type":"function"},{"doc":"Create a Paths map from a list of routes. Example Paths . from_routes ( [ %{ path : &quot;/v1/contacts&quot; , verb : :post , plug : MyAppWeb.V1.ContactController , plug_opts : :create } ] )","ref":"OpenApiSpex.Paths.html#from_routes/1","title":"OpenApiSpex.Paths.from_routes/1","type":"function"},{"doc":"Paths Object Holds the relative paths to the individual endpoints and their operations. The path is appended to the URL from the Server Object in order to construct the full URL. The Paths MAY be empty, due to ACL constraints.","ref":"OpenApiSpex.Paths.html#t:path/0","title":"OpenApiSpex.Paths.path/0","type":"type"},{"doc":"","ref":"OpenApiSpex.Paths.html#t:t/0","title":"OpenApiSpex.Paths.t/0","type":"type"},{"doc":"A cache implementation leveraging Application env.","ref":"OpenApiSpex.Plug.AppEnvCache.html","title":"OpenApiSpex.Plug.AppEnvCache","type":"module"},{"doc":"Cache for OpenApiSpex API specs. Settings: config :open_api_spex , :cache_adapter , Module There are three cache implementations: OpenApiSpex.Plug.PersistentTermCache - default OpenApiSpex.Plug.AppEnvCache - for VMs that don't support persistent_term OpenApiSpex.Plug.NoneCache - none cache If you are constantly modifying specs during development, you can configure the cache adapter in dev.exs as follows to disable caching: config :open_api_spex , :cache_adapter , OpenApiSpex.Plug.NoneCache","ref":"OpenApiSpex.Plug.Cache.html","title":"OpenApiSpex.Plug.Cache","type":"behaviour"},{"doc":"Get cache adapter","ref":"OpenApiSpex.Plug.Cache.html#adapter/0","title":"OpenApiSpex.Plug.Cache.adapter/0","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:erase/1","title":"OpenApiSpex.Plug.Cache.erase/1","type":"callback"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:get/1","title":"OpenApiSpex.Plug.Cache.get/1","type":"callback"},{"doc":"","ref":"OpenApiSpex.Plug.Cache.html#c:put/2","title":"OpenApiSpex.Plug.Cache.put/2","type":"callback"},{"doc":"Only erase cache, put again when plug starting","ref":"OpenApiSpex.Plug.Cache.html#refresh/0","title":"OpenApiSpex.Plug.Cache.refresh/0","type":"function"},{"doc":"Module plug that will cast the Conn.params and Conn.body_params according to the schemas defined for the operation. Note that when using this plug, the body params are no longer merged into Conn.params and must be read from Conn.body_params separately. The operation_id can be given at compile time as an argument to init : plug OpenApiSpex.Plug.Cast , operation_id : &quot;MyApp.ShowUser&quot; For phoenix applications, the operation_id can be obtained at runtime automatically. defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast ... end If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast , render_error : MyApp.RenderError ... end defmodule MyApp.RenderError do def init ( opts ) , do : opts def call ( conn , reason ) do msg = %{ error : reason } |&gt; Poison . encode! ( ) conn |&gt; Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Conn . send_resp ( 400 , msg ) end end","ref":"OpenApiSpex.Plug.Cast.html","title":"OpenApiSpex.Plug.Cast","type":"module"},{"doc":"Module plug that will cast and validate the Conn.params and Conn.body_params according to the schemas defined for the operation. Note that when using this plug, the body params are no longer merged into Conn.params and must be read from Conn.body_params separately. The operation_id can be given at compile time as an argument to init : plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true , operation_id : &quot;MyApp.ShowUser&quot; For phoenix applications, the operation_id can be obtained at runtime automatically. defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true ... end Casted params and body params are always stored in conn.private . The option :replace_params can be set to false to avoid overwriting conn :body_params and :params with their casted version. plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true , operation_id : &quot;MyApp.ShowUser&quot; , replace_params : false If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyAppWeb.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.CastAndValidate , render_error : MyApp.RenderError ... end defmodule MyApp.RenderError do def init ( opts ) , do : opts def call ( conn , reason ) do msg = Jason . encode! ( %{ error : reason } ) conn |&gt; Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Conn . send_resp ( 400 , msg ) end end","ref":"OpenApiSpex.Plug.CastAndValidate.html","title":"OpenApiSpex.Plug.CastAndValidate","type":"module"},{"doc":"Renders errors using a quasi-json:api-compliant data shape. WARNING: Do not use this module directly. It will be renamed in version 4.0 To use this module in a backwards-compatible way, call CastAndValidate like this: plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true","ref":"OpenApiSpex.Plug.JsonRenderErrorV2.html","title":"OpenApiSpex.Plug.JsonRenderErrorV2","type":"module"},{"doc":"A cache adapter to disable caching. Intended to be used in development. Configure it with: # config/dev.exs config :open_api_spex , :cache_adapter , OpenApiSpex.Plug.NoneCache","ref":"OpenApiSpex.Plug.NoneCache.html","title":"OpenApiSpex.Plug.NoneCache","type":"module"},{"doc":"A cache leveraging :persistent_term .","ref":"OpenApiSpex.Plug.PersistentTermCache.html","title":"OpenApiSpex.Plug.PersistentTermCache","type":"module"},{"doc":"Module plug that calls a given module to obtain the Api Spec and store it as private in the Conn. This allows downstream plugs to use the API spec for casting, validating and rendering. Options module: A module implementing the OpenApiSpex.OpenApi behaviour Example plug OpenApiSpex.Plug.PutApiSpec , module : MyAppWeb.ApiSpec","ref":"OpenApiSpex.Plug.PutApiSpec.html","title":"OpenApiSpex.Plug.PutApiSpec","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#get_and_cache_controller_action/3","title":"OpenApiSpex.Plug.PutApiSpec.get_and_cache_controller_action/3","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#get_spec_and_operation_lookup/1","title":"OpenApiSpex.Plug.PutApiSpec.get_spec_and_operation_lookup/1","type":"function"},{"doc":"","ref":"OpenApiSpex.Plug.PutApiSpec.html#spec_module/1","title":"OpenApiSpex.Plug.PutApiSpec.spec_module/1","type":"function"},{"doc":"Renders the API spec as a JSON response. The API spec must be stored in the conn by OpenApiSpex.Plug.PutApiSpec earlier in the plug pipeline. Example defmodule MyAppWeb.Router do use Phoenix.Router alias MyAppWeb.UserController pipeline :api do plug :accepts , [ &quot;json&quot; ] plug OpenApiSpex.Plug.PutApiSpec , module : MyAppWeb.ApiSpec end scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot; , UserController , only : [ :create , :index , :show ] get &quot;/openapi&quot; , OpenApiSpex.Plug.RenderSpec , [ ] end end","ref":"OpenApiSpex.Plug.RenderSpec.html","title":"OpenApiSpex.Plug.RenderSpec","type":"module"},{"doc":"Module plug that serves SwaggerUI. The full path to the API spec must be given as a plug option. The API spec should be served at the given path, see OpenApiSpex.Plug.RenderSpec Configuring SwaggerUI SwaggerUI can be configured through plug opts . All options will be converted from snake_case to camelCase and forwarded to the SwaggerUIBundle constructor. See the swagger-ui configuration docs for details. Should dynamic configuration be required, the config_url option can be set to an API endpoint that will provide additional config. Example scope &quot;/&quot; do pipe_through :browser # Use the default browser stack get &quot;/&quot; , MyAppWeb.PageController , :index get &quot;/swaggerui&quot; , OpenApiSpex.Plug.SwaggerUI , path : &quot;/api/openapi&quot; , default_model_expand_depth : 3 , display_operation_id : true end # Other scopes may use custom stacks. scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot; , MyAppWeb.UserController , only : [ :index , :create , :show ] get &quot;/openapi&quot; , OpenApiSpex.Plug.RenderSpec , :show end","ref":"OpenApiSpex.Plug.SwaggerUI.html","title":"OpenApiSpex.Plug.SwaggerUI","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.SwaggerUI.html#get_nonce/3","title":"OpenApiSpex.Plug.SwaggerUI.get_nonce/3","type":"function"},{"doc":"Initializes the plug. Options :path - Required. The URL path to the API definition. :oauth - Optional. Config to pass to the SwaggerUIBundle.initOAuth() function. :csp_nonce_assign_key - Optional. An assign key to find the CSP nonce value used for assets. Supports either atom() or a map of type %{optional(:script) =&gt; atom(), optional(:style) =&gt; atom()} . You will probably want to set this on the SwaggerUIOAuth2Redirect plug as well. all other opts - forwarded to the SwaggerUIBundle constructor Example get &quot;/swaggerui&quot; , OpenApiSpex.Plug.SwaggerUI , path : &quot;/api/openapi&quot; , default_model_expand_depth : 3 , display_operation_id : true , csp_nonce_assign_key : %{ script : :script_src_nonce , style : :style_src_nonce }","ref":"OpenApiSpex.Plug.SwaggerUI.html#init/1","title":"OpenApiSpex.Plug.SwaggerUI.init/1","type":"function"},{"doc":"This plug will handle the callback from an OAuth server","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html","title":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect","type":"module"},{"doc":"Initializes the plug. Options :csp_nonce_assign_key - Optional. An assign key to find the CSP nonce value used for assets. Supports either atom() or a map of type %{optional(:script) =&gt; atom()} . Example get &quot;/oauth2-redirect.html&quot; , OpenApiSpex.Plug.SwaggerUIOAuth2Redirect , csp_nonce_assign_key : %{ script : :script_src_nonce }","ref":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.html#init/1","title":"OpenApiSpex.Plug.SwaggerUIOAuth2Redirect.init/1","type":"function"},{"doc":"Module plug that validates params against the schema defined for an operation. If validation fails, the plug will send a 422 response with the reason as the body. This plug should always be run after OpenApiSpex.Plug.Cast , as it expects the params map to have atom keys and query params converted from strings to the appropriate types. Example defmodule MyApp.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast plug OpenApiSpex.Plug.Validate ... end If you want customize the error response, you can provide the :render_error option to register a plug which creates a custom response in the case of a validation error. Example defmodule MyApp.UserController do use Phoenix.Controller plug OpenApiSpex.Plug.Cast plug OpenApiSpex.Plug.Validate , render_error : MyApp.RenderError def render_error ( conn , reason ) do msg = %{ error : reason } |&gt; Poison . encode! ( ) conn |&gt; Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Conn . send_resp ( 400 , msg ) end ... end defmodule MyApp.RenderError do def init ( opts ) , do : opts def call ( conn , reason ) do msg = %{ error : reason } |&gt; Poison . encode! ( ) conn |&gt; Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Conn . send_resp ( 400 , msg ) end end","ref":"OpenApiSpex.Plug.Validate.html","title":"OpenApiSpex.Plug.Validate","type":"module"},{"doc":"","ref":"OpenApiSpex.Plug.Validate.html#render_error/2","title":"OpenApiSpex.Plug.Validate.render_error/2","type":"function"},{"doc":"Defines the OpenApiSpex.Reference.t type.","ref":"OpenApiSpex.Reference.html","title":"OpenApiSpex.Reference","type":"module"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_parameter/2","title":"OpenApiSpex.Reference.resolve_parameter/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_request_body/2","title":"OpenApiSpex.Reference.resolve_request_body/2","type":"function"},{"doc":"","ref":"OpenApiSpex.Reference.html#resolve_response/2","title":"OpenApiSpex.Reference.resolve_response/2","type":"function"},{"doc":"Resolve a Reference to the Schema it refers to. Examples iex&gt; alias OpenApiSpex . { Reference , Schema } ...&gt; schemas = %{ &quot;user&quot; =&gt; % Schema { title : &quot;user&quot; , type : :object } } ...&gt; Reference . resolve_schema ( % Reference { &quot;$ref&quot; : &quot;#/components/schemas/user&quot; } , schemas ) % OpenApiSpex.Schema { type : :object , title : &quot;user&quot; }","ref":"OpenApiSpex.Reference.html#resolve_schema/2","title":"OpenApiSpex.Reference.resolve_schema/2","type":"function"},{"doc":"Reference Object A simple object to allow referencing other components in the specification, internally and externally. The Reference Object is defined by JSON Reference and follows the same structure, behavior and rules.","ref":"OpenApiSpex.Reference.html#t:t/0","title":"OpenApiSpex.Reference.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.RequestBody.t type.","ref":"OpenApiSpex.RequestBody.html","title":"OpenApiSpex.RequestBody","type":"module"},{"doc":"Request Body Object Describes a single request body.","ref":"OpenApiSpex.RequestBody.html#t:t/0","title":"OpenApiSpex.RequestBody.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Response.t type.","ref":"OpenApiSpex.Response.html","title":"OpenApiSpex.Response","type":"module"},{"doc":"Resolve a Reference to the Response it refers to. Examples iex&gt; alias OpenApiSpex . { Response , Reference } ...&gt; responses = %{ &quot;aresponse&quot; =&gt; % Response { description : &quot;Some response&quot; } } ...&gt; Response . resolve_response ( % Reference { &quot;$ref&quot; : &quot;#/components/responses/aresponse&quot; } , responses ) % OpenApiSpex.Response { description : &quot;Some response&quot; }","ref":"OpenApiSpex.Response.html#resolve_response/2","title":"OpenApiSpex.Response.resolve_response/2","type":"function"},{"doc":"Response Object Describes a single response from an API Operation, including design-time, static links to operations based on the response.","ref":"OpenApiSpex.Response.html#t:t/0","title":"OpenApiSpex.Response.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Responses.t type.","ref":"OpenApiSpex.Responses.html","title":"OpenApiSpex.Responses","type":"module"},{"doc":"Responses Object A container for the expected responses of an operation. The container maps a HTTP response code to the expected response. The documentation is not necessarily expected to cover all possible HTTP response codes because they may not be known in advance. However, documentation is expected to cover a successful operation response and any known errors. The default MAY be used as a default response object for all HTTP codes that are not covered individually by the specification. The Responses Object MUST contain at least one response code, and it SHOULD be the response for a successful operation call.","ref":"OpenApiSpex.Responses.html#t:t/0","title":"OpenApiSpex.Responses.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Schema.t type and operations for casting and validating against a schema. The OpenApiSpex.schema macro can be used to declare schemas with an associated struct and JSON Encoder. Examples defmodule MyApp.Schemas do defmodule EmailString do @behaviour OpenApiSpex.Schema def schema do % OpenApiSpex.Schema { title : &quot;EmailString&quot; , type : :string , format : :email } end end defmodule Person do require OpenApiSpex alias OpenApiSpex . { Reference , Schema } OpenApiSpex . schema ( %{ type : :object , required : [ :name ] , properties : %{ name : % Schema { type : :string } , address : % Reference { &quot;$ref&quot; : &quot;#/components/schemas/Address&quot; } , age : % Schema { type : :integer , format : :int32 , minimum : 0 } } } ) end defmodule StringDictionary do @behaviour OpenApiSpex.Schema def schema ( ) do % OpenApiSpex.Schema { type : :object , additionalProperties : % OpenApiSpex.Schema { type : :string } } end end defmodule PetCommon do require OpenApiSpex alias OpenApiSpex . { Schema , Discriminator } OpenApiSpex . schema ( %{ title : &quot;PetCommon&quot; , description : &quot;Properties common to all Pets&quot; , type : :object , properties : %{ name : % Schema { type : :string } , petType : % Schema { type : :string } } , required : [ :name , :petType ] } ) end defmodule Cat do require OpenApiSpex alias OpenApiSpex.Schema OpenApiSpex . schema ( %{ title : &quot;Cat&quot; , type : :object , description : &quot;A representation of a cat. Note that `Cat` will be used as the discriminator value.&quot; , allOf : [ PetCommon , % Schema { type : :object , properties : %{ huntingSkill : % Schema { type : :string , description : &quot;The measured skill for hunting&quot; , default : &quot;lazy&quot; , enum : [ &quot;clueless&quot; , &quot;lazy&quot; , &quot;adventurous&quot; , &quot;aggressive&quot; ] } } , required : [ :huntingSkill ] } ] } ) end defmodule Dog do require OpenApiSpex alias OpenApiSpex.Schema OpenApiSpex . schema ( %{ type : :object , title : &quot;Dog&quot; , description : &quot;A representation of a dog. Note that `Dog` will be used as the discriminator value.&quot; , allOf : [ PetCommon , % Schema { type : :object , properties : %{ packSize : % Schema { type : :integer , format : :int32 , description : &quot;the size of the pack the dog is from&quot; , default : 0 , minimum : 0 } } , required : [ :packSize ] } ] } ) end defmodule Pet do require OpenApiSpex alias OpenApiSpex.Discriminator OpenApiSpex . schema ( %{ title : &quot;Pet&quot; , type : :object , discriminator : % Discriminator { propertyName : &quot;petType&quot; } , oneOf : [ Cat , Dog ] } ) end end","ref":"OpenApiSpex.Schema.html","title":"OpenApiSpex.Schema","type":"behaviour"},{"doc":"Cast a simple value to the elixir type defined by a schema. By default, object types are cast to maps, however if the &quot;x-struct&quot; attribute is set in the schema, the result will be constructed as an instance of the given struct type. Examples iex&gt; OpenApiSpex.Schema . cast ( % Schema { type : :integer } , &quot;123&quot; , %{ } ) { :ok , 123 } iex&gt; { :ok , dt = % DateTime { } } = OpenApiSpex.Schema . cast ( % Schema { type : :string , format : :&quot;date-time&quot; } , &quot;2018-04-02T13:44:55Z&quot; , %{ } ) ...&gt; dt |&gt; DateTime . to_iso8601 ( ) &quot;2018-04-02T13:44:55Z&quot; Casting Polymorphic Schemas Schemas using discriminator , allOf , oneOf , anyOf are cast using the following rules: If a discriminator is present, cast the properties defined in the base schema, then cast the result using the schema identified by the discriminator. To avoid infinite recursion, the discriminator is only dereferenced if the discriminator property has not already been cast. Cast the properties using each schema listing in allOf . When a property is defined in multiple allOf schemas, it will be cast using the first schema listed containing the property. Cast the value using each schema listed in oneOf , stopping as soon as a successful cast is made. Cast the value using each schema listed in anyOf , stopping as soon as a successful cast is made.","ref":"OpenApiSpex.Schema.html#cast/3","title":"OpenApiSpex.Schema.cast/3","type":"function"},{"doc":"Generate example value from a %Schema{} struct. This is useful as a simple way to generate values for tests. Example: test &quot;create user&quot; , %{ conn : conn } do user_request_schema = MyAppWeb.Schemas.UserRequest . schema ( ) req_body = OpenApiSpex.Schema . example ( user_request_schema ) resp_body = conn |&gt; post ( &quot;/users&quot; , req_body ) |&gt; json_response ( 201 ) assert ... end","ref":"OpenApiSpex.Schema.html#example/1","title":"OpenApiSpex.Schema.example/1","type":"function"},{"doc":"Generate example value from a OpenApiSpex.Schema or a OpenApiSpex.Reference struct. The second parameter must either be an OpenApiSpex.OpenApi struct or a map of schemas. See also: example/1 .","ref":"OpenApiSpex.Schema.html#example/2","title":"OpenApiSpex.Schema.example/2","type":"function"},{"doc":"Get the names of all properties defined for a schema. Includes all properties directly defined in the schema, and all schemas included in the allOf list.","ref":"OpenApiSpex.Schema.html#properties/1","title":"OpenApiSpex.Schema.properties/1","type":"function"},{"doc":"A module implementing the OpenApiSpex.Schema behaviour should export a schema/0 function that produces an OpenApiSpex.Schema struct.","ref":"OpenApiSpex.Schema.html#c:schema/0","title":"OpenApiSpex.Schema.schema/0","type":"callback"},{"doc":"Validate a value against a Schema. This expects that the value has already been cast to the appropriate data type. Examples iex&gt; OpenApiSpex.Schema . validate ( % OpenApiSpex.Schema { type : :integer , minimum : 5 } , 3 , %{ } ) { :error , &quot;#: 3 is smaller than minimum 5&quot; } iex&gt; OpenApiSpex.Schema . validate ( % OpenApiSpex.Schema { type : :string , pattern : &quot;(.*)@(.*)&quot; } , &quot;joe@gmail.com&quot; , %{ } ) :ok iex&gt; OpenApiSpex.Schema . validate ( % OpenApiSpex.Schema { type : :string , pattern : &quot;(.*)@(.*)&quot; } , &quot;joegmail.com&quot; , %{ } ) { :error , &quot;#: Value \\&quot; joegmail.com \\&quot; does not match pattern: (.*)@(.*)&quot; }","ref":"OpenApiSpex.Schema.html#validate/3","title":"OpenApiSpex.Schema.validate/3","type":"function"},{"doc":"See OpenApiSpex.DeprecatedCast.validate/4 .","ref":"OpenApiSpex.Schema.html#validate/4","title":"OpenApiSpex.Schema.validate/4","type":"function"},{"doc":"The basic data types supported by openapi. Reference","ref":"OpenApiSpex.Schema.html#t:data_type/0","title":"OpenApiSpex.Schema.data_type/0","type":"type"},{"doc":"Global schemas lookup by name.","ref":"OpenApiSpex.Schema.html#t:schemas/0","title":"OpenApiSpex.Schema.schemas/0","type":"type"},{"doc":"Schema Object The Schema Object allows the definition of input and output data types. These types can be objects, but also primitives and arrays. This object is an extended subset of the JSON Schema Specification Wright Draft 00. Example alias OpenApiSpex.Schema % Schema { title : &quot;User&quot; , type : :object , properties : %{ id : % Schema { type : :integer , minimum : 1 } , name : % Schema { type : :string , pattern : &quot;[a-zA-Z][a-zA-Z0-9_]+&quot; } , email : % Schema { type : :string , format : :email } , last_login : % Schema { type : :string , format : :&quot;date-time&quot; } } , required : [ :name , :email ] , example : %{ &quot;name&quot; =&gt; &quot;joe&quot; , &quot;email&quot; =&gt; &quot;joe@gmail.com&quot; } }","ref":"OpenApiSpex.Schema.html#t:t/0","title":"OpenApiSpex.Schema.t/0","type":"type"},{"doc":"Rules of API Schema consistency. If these rules are not followed, tricky run-time bugs may appear. Related issues: #144","ref":"OpenApiSpex.SchemaConsistency.html","title":"OpenApiSpex.SchemaConsistency","type":"module"},{"doc":"Returns a list of compile-time warnings","ref":"OpenApiSpex.SchemaConsistency.html#warnings/1","title":"OpenApiSpex.SchemaConsistency.warnings/1","type":"function"},{"doc":"Internal module used to resolve OpenApiSpex.Schema structs from atoms.","ref":"OpenApiSpex.SchemaResolver.html","title":"OpenApiSpex.SchemaResolver","type":"module"},{"doc":"Adds schemas to the api spec from the modules specified in the Operations. Eg, if the response schema for an operation is defined with: responses : %{ 200 =&gt; Operation . response ( &quot;User&quot; , &quot;application/json&quot; , UserResponse ) } Then the UserResponse.schema() function will be called to load the schema, and a Reference to the loaded schema will be used in the operation response. See OpenApiSpex.schema macro for a convenient syntax for defining schema modules.","ref":"OpenApiSpex.SchemaResolver.html#resolve_schema_modules/1","title":"OpenApiSpex.SchemaResolver.resolve_schema_modules/1","type":"function"},{"doc":"Defines the OpenApiSpex.SecurityRequirement.t type.","ref":"OpenApiSpex.SecurityRequirement.html","title":"OpenApiSpex.SecurityRequirement","type":"module"},{"doc":"Security Requirement Object Lists the required security schemes to execute this operation. The name used for each property MUST correspond to a security scheme declared in the Security Schemes under the Components Object. Security Requirement Objects that contain multiple schemes require that all schemes MUST be satisfied for a request to be authorized. This enables support for scenarios where multiple query parameters or HTTP headers are required to convey security information. When a list of Security Requirement Objects is defined on the Open API object or Operation Object, only one of Security Requirement Objects in the list needs to be satisfied to authorize the request.","ref":"OpenApiSpex.SecurityRequirement.html#t:t/0","title":"OpenApiSpex.SecurityRequirement.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.SecurityScheme.t type.","ref":"OpenApiSpex.SecurityScheme.html","title":"OpenApiSpex.SecurityScheme","type":"module"},{"doc":"Security Scheme Object Defines a security scheme that can be used by the operations. Supported schemes are HTTP authentication, an API key (either as a header or as a query parameter), OAuth2's common flows (implicit, password, application and access code) as defined in RFC6749, and OpenID Connect Discovery.","ref":"OpenApiSpex.SecurityScheme.html#t:t/0","title":"OpenApiSpex.SecurityScheme.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Server.t type.","ref":"OpenApiSpex.Server.html","title":"OpenApiSpex.Server","type":"module"},{"doc":"Builds a Server from a phoenix Endpoint module","ref":"OpenApiSpex.Server.html#from_endpoint/1","title":"OpenApiSpex.Server.from_endpoint/1","type":"function"},{"doc":"Builds a Server from a phoenix Endpoint module","ref":"OpenApiSpex.Server.html#from_endpoint/2","title":"OpenApiSpex.Server.from_endpoint/2","type":"function"},{"doc":"Server Object An object representing a Server.","ref":"OpenApiSpex.Server.html#t:t/0","title":"OpenApiSpex.Server.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.ServerVariable.t type.","ref":"OpenApiSpex.ServerVariable.html","title":"OpenApiSpex.ServerVariable","type":"module"},{"doc":"Server Variable Object An object representing a Server Variable for server URL template substitution.","ref":"OpenApiSpex.ServerVariable.html#t:t/0","title":"OpenApiSpex.ServerVariable.t/0","type":"type"},{"doc":"Defines the OpenApiSpex.Tag.t type.","ref":"OpenApiSpex.Tag.html","title":"OpenApiSpex.Tag","type":"module"},{"doc":"Tag Object Adds metadata to a single tag that is used by the Operation Object. It is not mandatory to have a Tag Object per tag defined in the Operation Object instances.","ref":"OpenApiSpex.Tag.html#t:t/0","title":"OpenApiSpex.Tag.t/0","type":"type"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.Test.Assertions.html","title":"OpenApiSpex.Test.Assertions","type":"module"},{"doc":"Asserts that value conforms to the schema with title schema_title in api_spec .","ref":"OpenApiSpex.Test.Assertions.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions.assert_schema/3","type":"function"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.Test.Assertions2.html","title":"OpenApiSpex.Test.Assertions2","type":"module"},{"doc":"Asserts that value conforms to the schema with title schema_title in api_spec .","ref":"OpenApiSpex.Test.Assertions2.html#assert_schema/3","title":"OpenApiSpex.Test.Assertions2.assert_schema/3","type":"function"},{"doc":"Defines helpers for testing API responses and examples against API spec schemas.","ref":"OpenApiSpex.TestAssertions.html","title":"OpenApiSpex.TestAssertions","type":"module"},{"doc":"Asserts that the response body conforms to the response schema for the operation with id operation_id .","ref":"OpenApiSpex.TestAssertions.html#assert_operation_response/2","title":"OpenApiSpex.TestAssertions.assert_operation_response/2","type":"function"},{"doc":"Asserts that value conforms to the schema or reference definition.","ref":"OpenApiSpex.TestAssertions.html#assert_raw_schema/3","title":"OpenApiSpex.TestAssertions.assert_raw_schema/3","type":"function"},{"doc":"Asserts that value is a valid request schema with title schema_title in api_spec . In this case, the presence of required readOnly fields is not validated.","ref":"OpenApiSpex.TestAssertions.html#assert_request_schema/3","title":"OpenApiSpex.TestAssertions.assert_request_schema/3","type":"function"},{"doc":"Asserts that value is a valid response schema with title schema_title in api_spec . In this case, the presence of required writeOnly fields is not validated.","ref":"OpenApiSpex.TestAssertions.html#assert_response_schema/3","title":"OpenApiSpex.TestAssertions.assert_response_schema/3","type":"function"},{"doc":"Asserts that value conforms to the schema in the given %Cast{} context.","ref":"OpenApiSpex.TestAssertions.html#assert_schema/1","title":"OpenApiSpex.TestAssertions.assert_schema/1","type":"function"},{"doc":"Asserts that value conforms to the schema with title schema_title in api_spec .","ref":"OpenApiSpex.TestAssertions.html#assert_schema/4","title":"OpenApiSpex.TestAssertions.assert_schema/4","type":"function"},{"doc":"Defines the OpenApiSpex.Xml.t type.","ref":"OpenApiSpex.Xml.html","title":"OpenApiSpex.Xml","type":"module"},{"doc":"XML Object A metadata object that allows for more fine-tuned XML model definitions. When using arrays, XML element names are not inferred (for singular/plural forms) and the name property SHOULD be used to add that information. See examples for expected behavior.","ref":"OpenApiSpex.Xml.html#t:t/0","title":"OpenApiSpex.Xml.t/0","type":"type"},{"doc":"","ref":"OpenApiSpex.SchemaException.html","title":"OpenApiSpex.SchemaException","type":"exception"},{"doc":"All notable changes to this project will be documented in this file. The format is based on Keep a Changelog , and this project adheres to Semantic Versioning .","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"Support custom error messages in custom validators by @GregorGrasselli in https://github.com/open-api-spex/open_api_spex/pull/621 Update Schema.example/2 typespec to allow references by @zorbash in 5ec452f","ref":"changelog.html#v3-20-1-2024-07-31","title":"Changelog - v3.20.1 - 2024-07-31","type":"extras"},{"doc":"Respect minLength when generating string examples by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/608 Accept read_write_scope from opts when calling cast functions directly by @albertored in https://github.com/open-api-spex/open_api_spex/pull/572 Allow Poison v6 to be used by @hkrutzer in https://github.com/open-api-spex/open_api_spex/pull/616 chore: Drop build matrix support for elixir 1.11, 1.12, 1.13 and OTP 22 by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/619 improvement: use struct spec to avoid double % in struct inspect by @zachdaniel in https://github.com/open-api-spex/open_api_spex/pull/613 Feat: add --check option in Mix tasks to compare the generated spec with a previously generated file by @davidebriani in https://github.com/open-api-spex/open_api_spex/pull/618 fix: cast numbers as floats by @David-Klemenc in https://github.com/open-api-spex/open_api_spex/pull/611","ref":"changelog.html#v3-20-0-2024-07-10","title":"Changelog - v3.20.0 - 2024-07-10","type":"extras"},{"doc":"Add notice that body params are not merged into Conn.params whne using cast and validate plug by @hamir-suspect in #589 Set nonces on &lt;script&gt; and &lt;style&gt; elements if configured by @nathanalderson in #593 Ensure operation_id is always set on conn.private by @msutkowski in #606","ref":"changelog.html#v3-19-1-2024-05-17","title":"Changelog - v3.19.1 - 2024-05-17","type":"extras"},{"doc":"Support response code ranges by @zorbash in 8898859da1","ref":"changelog.html#v3-19-0-2024-04-30","title":"Changelog - v3.19.0 - 2024-04-30","type":"extras"},{"doc":"Relax dependency constraint on ymlr to allow version ~&gt; 5.0 by @egze in https://github.com/open-api-spex/open_api_spex/pull/586","ref":"changelog.html#v3-18-3-2024-03-15","title":"Changelog - v3.18.3 - 2024-03-15","type":"extras"},{"doc":"Fix 'AllOf cast returns a map, but I expected a struct' by @angelikatyborska in https://github.com/open-api-spex/open_api_spex/pull/592","ref":"changelog.html#v3-18-2-2024-01-26","title":"Changelog - v3.18.2 - 2024-01-26","type":"extras"},{"doc":"Fix assert_operation_response/2 header lookup by @msutkowski in https://github.com/open-api-spex/open_api_spex/pull/584 Exclude empty paths ( operation false ) from generated spec by @alisinabh in https://github.com/open-api-spex/open_api_spex/pull/583 Cast discriminator when no title present (#574) by @albertored in https://github.com/open-api-spex/open_api_spex/pull/574 Docstest Operation.parameter/5 by @zorbash Document the spec export task --filename option by @zorbash","ref":"changelog.html#v3-18-1-2023-12-19","title":"Changelog - v3.18.1 - 2023-12-19","type":"extras"},{"doc":"Relax dependency constraint on ymlr to allow version ~&gt; 4.0 by @arcanemachine in https://github.com/open-api-spex/open_api_spex/pull/544 Fix deprecation warning on Elixir 1.15, require Elixir 1.11, adapt CI by @thbar in https://github.com/open-api-spex/open_api_spex/pull/550 Add --quiet option for spec generation by @Cowa in https://github.com/open-api-spex/open_api_spex/pull/557 Fix casting non-objects against discriminator #551 by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/552 feat: add assert_operation_response, assert_raw_schema by @msutkowski in https://github.com/open-api-spex/open_api_spex/pull/545","ref":"changelog.html#v3-18-0-2023-08-23","title":"Changelog - v3.18.0 - 2023-08-23","type":"extras"},{"doc":"Raise meaningful error message when SchemaResolver.resolve_schema_modules_from_schema failed to pattern match by @yuchunc in https://github.com/open-api-spex/open_api_spex/pull/541 Support structs as inputs when casting objects by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/529 Fix #540 PathItem.from_routes/1 dialyzer warnings - @zorbash - 055c8e0131a4f8","ref":"changelog.html#v3-17-3-2023-05-30","title":"Changelog - v3.17.3 - 2023-05-30","type":"extras"},{"doc":"Fix Schema.example/2 for anyOf - @zorbash - 3046c68","ref":"changelog.html#v3-17-2-2023-05-26","title":"Changelog - v3.17.2 - 2023-05-26","type":"extras"},{"doc":"Add missing Reference.resolve_response/2 - @zorbash - a5bd81dac","ref":"changelog.html#v3-17-1-2023-05-22","title":"Changelog - v3.17.1 - 2023-05-22","type":"extras"},{"doc":"Support passing a %Reference{} as a response when doing controller specs by @mracos in https://github.com/open-api-spex/open_api_spex/pull/532 Implement OpenApiSpex.Schema.example/2 which resolves references - @zorbash - 45a26f045776","ref":"changelog.html#v3-17-0-2023-05-18","title":"Changelog - v3.17.0 - 2023-05-18","type":"extras"},{"doc":"Ensure schemas with discriminator work with atom-keyed maps - a7b8067a7a Ensure spec decoding converts required items into atoms for allOf / anyOf / oneOf - a7b8067a7a","ref":"changelog.html#v3-16-4-2023-05-17","title":"Changelog - v3.16.4- 2023-05-17","type":"extras"},{"doc":"Keep discriminator errors relevant by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/533 Avoid compile time dependencies by @doorgan in https://github.com/open-api-spex/open_api_spex/pull/536","ref":"changelog.html#v3-16-3-2023-05-02","title":"Changelog - v3.16.3 - 2023-05-02","type":"extras"},{"doc":"Infer moduledoc from schema by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/525 Fix typespec and add example to Paths.from_routes/1 by @thiagogsr in https://github.com/open-api-spex/open_api_spex/pull/534","ref":"changelog.html#v3-16-2-2023-04-13","title":"Changelog - v3.16.2 - 2023-04-13","type":"extras"},{"doc":"Accept dates and datetimes in formatted string schemas by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/524","ref":"changelog.html#v3-16-1-2023-02-07","title":"Changelog - v3.16.1 - 2023-02-07","type":"extras"},{"doc":"Optimise property counting for object validations by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/514 Omit required from schemas when list is empty by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/515","ref":"changelog.html#v3-16-0-2022-11-23","title":"Changelog - v3.16.0 - 2022-11-23","type":"extras"},{"doc":"Resolve schema modules in discriminator mapping by @mbuhot in https://github.com/open-api-spex/open_api_spex/pull/511","ref":"changelog.html#v3-15-0-2022-11-02","title":"Changelog - v3.15.0 - 2022-11-02","type":"extras"},{"doc":"Thanks to the contributions of the community @zorbash @thbar @gmile @lucacorti Enhancement: Allow casting atoms as strings by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/497 Fix: Relax dependency constraint on ymlr by @thbar in https://github.com/open-api-spex/open_api_spex/pull/502 Enhancement: Implement casting of &quot;byte&quot; string type by @gmile in https://github.com/open-api-spex/open_api_spex/pull/504 Enhancement: Make OpenApiSpex.resolve_schema/2 work with schema modules by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/458 Fix: Fix oneOf/allOf/anyOf and schema module in Discriminator mapping by @lucacorti in https://github.com/open-api-spex/open_api_spex/pull/455","ref":"changelog.html#v3-14-0-2022-10-23","title":"Changelog - v3.14.0 - 2022-10-23","type":"extras"},{"doc":"Thanks to the contributions of the community @MichalDolata @mbuhot @zorbash @albertored @rolandtritsch @natali-maximenko @Eein Docs: Document OpenApiSpex.Plug.NoneCache #480 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/480 Enhancement: Improve example apps #481 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/481 Infrastructure: Fix CI workflow by @mbuhot Enhancement: Fix compilation warnings #479 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/479 Enhancement: Allow to configure casting to not automatically populate default values #460 by @albertored in https://github.com/open-api-spex/open_api_spex/pull/460 Fix: (UndefinedFunctionError) #447 by @rolandtritsch in https://github.com/open-api-spex/open_api_spex/pull/447 Enhancement: Allow omitting parens in test assertion functions #485 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/485 Fix: not schemas not decoded correctly #484 by @albertored in https://github.com/open-api-spex/open_api_spex/pull/484 Enhancement: Add --start-app option in openapi generation task #489 by @natali-maximenko in https://github.com/open-api-spex/open_api_spex/pull/489 Enhancement: Loosen poison dependency to allow using version 3.0 #483 by @Eein in https://github.com/open-api-spex/open_api_spex/pull/483 Enhancement: Bump swagger-ui JS dependency to 4.14.0 by @zorbash Full Changelog : https://github.com/open-api-spex/open_api_spex/compare/v3.12.0...v3.13.0","ref":"changelog.html#v3-13-0-2022-09-24","title":"Changelog - v3.13.0 - 2022-09-24","type":"extras"},{"doc":"Thanks to the contributions of the community @pxp9 @tfwright @juantascon @riccardomanfrin @rogerweb @zorbash @gianluca-nitti @MichalDolata @Geekfish @lazebny @Eein Docs: Solve Issue #396 by @pxp9 in https://github.com/open-api-spex/open_api_spex/pull/397 Docs: Clarify controller example by @tfwright in https://github.com/open-api-spex/open_api_spex/pull/405 Fix: Consider one-shot additionalProperties in .decode() by @zoten in https://github.com/open-api-spex/open_api_spex/pull/413 Fix: Casting Encoding without style field by @juantascon in https://github.com/open-api-spex/open_api_spex/pull/395 Fix: Adds responses dereferencing by @riccardomanfrin in https://github.com/open-api-spex/open_api_spex/pull/400 Docs: Fix typos by @kianmeng in https://github.com/open-api-spex/open_api_spex/pull/414 Enhancement: Implement Extendable protocol for all structs that can have extensions by @albertored in https://github.com/open-api-spex/open_api_spex/pull/415 Fix: decode/1 function correctly populates the :extensions field of structs by @albertored in https://github.com/open-api-spex/open_api_spex/pull/416 Fix: Allow empty schemas to be validated as wildcards by @zoten in https://github.com/open-api-spex/open_api_spex/pull/419 Docs: Fix schema example minor syntax issues (#431) by @rogerweb in https://github.com/open-api-spex/open_api_spex/pull/433 Enhancement: Bump swagger_ui version to 4.6.2 by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/437 Enhancement: Implement flag to omit vendor extensions in mix openapi.spec.json by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/439 Enhancement: Generate examples for UUID formatted strings by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/444 Enhancement: Format code with mix format by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/449 Docs: Fix typo in result of JsonErrorResponse.response() by @gianluca-nitti in https://github.com/open-api-spex/open_api_spex/pull/448 Fix: Avoids overwriting Plug.Conn body_params and params with the cast outcome by @albertored in https://github.com/open-api-spex/open_api_spex/pull/425 Enhancement: Multiple content types by @moxley in https://github.com/open-api-spex/open_api_spex/pull/451 Fix: llow empty content for Response by @MichalDolata in https://github.com/open-api-spex/open_api_spex/pull/453 Infrastructure: Improve CI pipeline by @lucacorti in https://github.com/open-api-spex/open_api_spex/pull/377 Fix: upport RequestBody passed to operation macro by @Geekfish in https://github.com/open-api-spex/open_api_spex/pull/456 Enhancement: Allow extensions in all OpenApi structures by @albertored in https://github.com/open-api-spex/open_api_spex/pull/438 Enhancement: ast parameters with json content-type by @albertored in https://github.com/open-api-spex/open_api_spex/pull/445 Docs: Code formatting in README by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/459 Validate :integer type format by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/465 Fix: Do not accepting float number in integer type by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/468 Fix: anyOf cast crash when Cast.cast return a struct by @wingyplus in https://github.com/open-api-spex/open_api_spex/pull/469 Fix: Decoding of discriminators when type: object is present by @albertored in https://github.com/open-api-spex/open_api_spex/pull/471 Fix: Correctly cast not map bodies (plug puts them under _json key) by @albertored in https://github.com/open-api-spex/open_api_spex/pull/470 Enhancement: Add YAML formatter #463 by @lazebny in https://github.com/open-api-spex/open_api_spex/pull/464 Enhancement: use cache adapter at runtime instead of compile time for PutApiSpec by @Eein in https://github.com/open-api-spex/open_api_spex/pull/461 Infrastructure: Build and publish a hex.pm package automatically by @zorbash in https://github.com/open-api-spex/open_api_spex/pull/474 Full Changelog : https://github.com/open-api-spex/open_api_spex/compare/v3.11.0...v3.12.0","ref":"changelog.html#v3-12-0-2022-07-21","title":"Changelog - v3.12.0 - 2022-07-21","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 @asppsa @ElijahBrandyberry @kianmeng @lucacorti @m0rt3nlund @mbuhot @moxley @nimish-mehta @reneweteling @stefanluptak @vitorbortolotti @vorce @ycherniavskyi @zoten seantanly Docs: Fix Application.spec/2 example in README #344 Docs: Misc doc changes (#355) Docs: JsonApiErrorResponse vs JsonErrorResponse (#385) Enhancement: Allow casting params where parameter.content schema is a Reference (#356) Enhancement: external_docs via controller @doc and @moduledoc or ControllerSpecs DSL (#329) Enhancement: Add optional header in opts to Operation.response (#332) Enhancement: Add callback support to operation_spec (#345) Enhancement: Adding helpers to OpenApiSpex.TestAssertions (#343) Enhancement: Collect all errors occurred during cast properties (#354) Enhancement: Add support for multiple specs for the same Phoenix router (#369) Enhancement: updated swagger-ui to 3.34.0 (#378) Fix casting additionalProperties (#386) Fix JsonErrorResponse schema definition (#383) Fix: test for cast of query parameters with style: form and explode: false (#364) Fix: any_of cast for multiple schemas (#366) Fix: Handle oneOf cast when there are multiple success along with failure (#362) Fix: Casting of additionalProperties with references (#360) Fix: Schema.example/1 for schema module (#358) Fix: Stop circular dependency by injecting the schema into list of already processed schemas (#352) Fix: Cast default for referenced schema (#337) Fix: don't json encode swagger-ui methods (#325) Fix: relax requirement on poison preventing version conflicts in library usage (#322) Fix: Allow top level security to apply to operations #321 Fix: return error tuple when discriminator cast fails (#393) Infrastructure: Run Elixir CI with GitHub Actions (#347)","ref":"changelog.html#v3-11-0-2021-10-29","title":"Changelog - v3.11.0 - 2021-10-29","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 noozo sernajoto pacoguzman vitorleal zlarsen surik brentjr dwmcc wingyplus Feature: Support OAuth2 for swagger-ui (#217) Feature: Support default response type in responses (#301) Feature: Allow overriding x*struct in OpenApiSpex.schema/1 (#304) Feature: Ability to specify deprecated in ControllerSpec operation (#296) Feature: :struct? and :derive? options in OpenApiSpex.schema/1 (#312) Feature: OpenApiSpex.add_schemas/2 (#314) Enhancement: Remove api_spec data from Conn (#286) Enhancement: More informative errors for bad schema (#288, #284, #287) Fix: Convert :format value to atom when decoding schema file (#293) Fix: Type spec in OpenApiSpex.Info Fix: Elixir Formatter rules in published package (#306) Docs: Fix spelling error in example code (#295) Docs: Fix type in README (#297) Docs: Fix links and punctuation in README (#298) Docs: Promote ControlerSpecs as the preferred API for controller operations (#311)","ref":"changelog.html#v3-10-0-2021-01-11","title":"Changelog - v3.10.0 - 2021-01-11","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 feng19 jbernardo95 Feature: Generate example from schema (#266) Feature: Allow SwaggerUI to be configured via Plug opts (#271) Feature: Warn on invalid or missing operation specs (#273, #278) Feature: Experimental alternative API for defining Operation specs (#265, #280) Fix: Handle the same operation occurring at different routes (#272) Fix: Casting header names that have upper case letters in specs (#281) Maint: Upgrade Elixir dependencies in example projects (#269) Maint: Format project with Elixir Formatter (#279)","ref":"changelog.html#v3-9-0-2020-09-14","title":"Changelog - v3.9.0 - 2020-09-14","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 feng19 gdiasdasilva mojidabckuu noozo Shikanime slashdotdash velimir wardes Feature: Custom validators (#243) Feature: Swagger json generation Mix Task (#249) Feature: Customizable cache adapter (#262) Enhancement: Allow passsing false to @doc annotation to skip the warning. (#236) Enhancement: Make @doc parameters declaration consistent with open api (#237) Enhancement: Support security @doc string attribute on operations (#251) Enhancement: Allow a Reference to be used for directly in the parameters definition (#258) Enhancement: Allow a Reference to be used for an Operation's request body (#260) Docs: Fixes README.md responses example typo &quot;unprocessible&quot; (#248) Docs: Fix security example to use correct types for the keys (#239) Fix: Remove default pop value for :type shortcut in @doc specs (#238) Fix: Nested parameters when served from file based schema (#241) Fix: Error handling for oneOf (#246) Fix: json:api compatible data shape option for JsonRenderError (#245) Fix: ReferenceError: components.parameter missing s in CastParamters (#257) Fix: struct def for custom validators (#263)","ref":"changelog.html#v3-8-0-2020-08-22","title":"Changelog - v3.8.0 - 2020-08-22","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 soundmonster slapers pedroassumpcao petersenlance mdogo minibikini rinpatch palcalde Enhancement: Multiple bug fixes and edge case handling of ExDoc based operation specs Enhancement: Upgrade Swagger UI to 3.24.2 (#210) Enhancement: Improve oneOf casting (#227) Docs: Add SecurityScheme usage and examples in the readme (#215) Fix: References for query params and discriminators with mappings not working (#200) Fix: Errors in parameter pattern validation (#206) Fix example (#212) Fix: CastAndValidate: incorrect content-type handling (#218) Fix: Can't cast and validate a JSON array as request body (#229)","ref":"changelog.html#v3-7-0-2020-06-05","title":"Changelog - v3.7.0 - 2020-06-05","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 Zakjholt supermaciz mrmstn aisrael Feature: Improved inspect output of %Schema{} (#193) Feature: Auto-populate schema title from module name (#192) Feature: Derive Operation ID from meta in ExDoc specs (#195) Fix: Validation of array minItems ignores empty array (#179) Fix: Add minimum/maximum validation for number properties (#181) Fix: Properly validate header params (#184) Fix: Support free-form query parameters (#171) Fix: Resolve schema modules from Response in Components (#186)","ref":"changelog.html#v3-6-0-2020-02-13","title":"Changelog - v3.6.0 - 2020-02-13","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 jung-hunsoo linnal Fix: Update README for Info from Application.spec/2 (#174) Fix: Casting for unsupported params (#170)","ref":"changelog.html#v3-5-2-2019-11-15","title":"Changelog - v3.5.2 - 2019-11-15","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 mrmstn Fix: Issues with complex types for phoenix endpoints (#161) Fix: In ExDoc-based operation spec (experimental), change key name used to define requestBody (#164) Fix: oneOf schema having object schemas (#167)","ref":"changelog.html#v3-5-1-2019-11-10","title":"Changelog - v3.5.1 - 2019-11-10","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 surik fmcgeough zero778 vovayartsev superhawk610 jung-hunsoo supermaciz Geekfish mrmstn waltfy ggpasqualino hauleth Feature: Ability to import Open API documents instead of defining them in Elixir (#152) Feature: Add display_operation_id option to SwaggerUI (#138) Feature: Schema validation: schema type required when properties is present (#146) Feature: Improve reporting of test assertion failures (#150) Feature: Support for min_properties validation for Object properties (#131) Feature: Support property defaults in new Cast &amp; Validate API (#145) Feature: Support for casting file uploads (#133) Feature: Support &quot;\\$ref&quot; in operation's parameters (#137) Feature: Experimental ExDoc-based endpoint API specifications (#162) Deprecation: Deprecate old cast and validation API (#153) Deprecation: Set minimum supported Elixir version to 1.7, maximum 1.9 (#130) Fix: Prevent example properties with nil values from being stripped out during JSON encoding (#142) Fix: casting/validating of oneOf, anyOf (#148) Fix: Pass additional properties through when allowed via additionalProperties (#155) Fix: for allOf definitions for multi-typed allOf array and complex structs with inheritance (#156) Fix: Allow a root-level property of compiled schema to be a schema (#158) Docs: Fix bugs and improve wording in README (#126) Docs: update phoenix guide and samples (#129) Docs: README instructions for separating API operation from controller (#140) The original cast &amp; validation API has been deprecated and replaced with an API that was introduced in 3.2.0. Using the old API will now result in compiler and runtime warnings. Old API: defmodule PhoenixAppWeb.UserController do use PhoenixAppWeb , :controller plug OpenApiSpex.Plug.Cast plug OpenApiSpex.Plug.Validate end Will result in: warning : OpenApiSpex.Plug.Cast . call / 2 is deprecated . Use OpenApiSpex.Plug.CastAndValidate instead test / support / user_controller . ex : 1 warning : OpenApiSpex.Plug.Validate . call / 2 is deprecated . Use OpenApiSpex.Plug.CastAndValidate . call / 2 instead test / support / user_controller . ex : 1 New API defmodule PhoenixAppWeb.UserController do use PhoenixAppWeb , :controller plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true end Note that this changes the default error response. Before, it was a single, plain-text error message. Now, it's a list of error maps, containing more error information. Old API: defmodule MyAppWeb.MyControllerTest do use MyApp.ConnCase # Old module import OpenApiSpex.Test.Assertions ## The test themselves don&#39;t need to change test &quot;UserController produces a UsersResponse&quot; , %{ conn : conn } do api_spec = MyApp.ApiSpec . spec ( ) json = conn |&gt; get ( user_path ( conn , :index ) ) |&gt; json_response ( 200 ) assert_schema ( json , &quot;UsersResponse&quot; , api_spec ) end test &quot;something&quot; do api_spec = MyApp.ApiSpec . spec ( ) schema = MyApp.Schemas.UsersResponse . schema ( ) assert_schema ( schema . example , &quot;UsersResponse&quot; , api_spec ) end end Will produce: warning : OpenApiSpex.Test.Assertions . assert_schema / 3 is deprecated . Use OpenApiSpex.TestAssertions . assert_schema / 3 instead test / my_controller_test . exs : 21 New API: defmodule MyAppWeb.MyControllerTest do use MyApp.ConnCase # New module import OpenApiSpex.TestAssertions # The test themselves don&#39;t need to change, # but the new assertion is more discerning, # so it may find problems that the old API didn&#39;t. end","ref":"changelog.html#v3-5-0-2019-10-29","title":"Changelog - v3.5.0 - 2019-10-29","type":"extras"},{"doc":"Thanks to the contributions of the community ❤️💙💛💜🧡 surik holsee fmcgeough Feature: the OpenApiSpex and OpenApiSpex.Info structs now support extensions (#108) (#114) The extensions key may contain any additional data that should be included in the info, eg the x-logo and x-tagGroups extensions: spec = % OpenApi { info : % Info { title : &quot;Test&quot; , version : &quot;1.0.0&quot; , extensions : %{ &quot;x-logo&quot; =&gt; %{ &quot;url&quot; =&gt; &quot;https://example.com/logo.png&quot; , &quot;backgroundColor&quot; =&gt; &quot;#FFFFFF&quot; , &quot;altText&quot; =&gt; &quot;Example logo&quot; } } } , extensions : %{ &quot;x-tagGroups&quot; =&gt; [ %{ &quot;name&quot; =&gt; &quot;Methods&quot; , &quot;tags&quot; =&gt; [ &quot;Search&quot; , &quot;Fetch&quot; , &quot;Delete&quot; ] } ] } , paths : %{ ... } } Deprecation: OpenApiSpex.Server.from_endpoint/2 has been deprecated in favor of OpenApiSpex.Server.from_endpoint/1 . Simply remove the otp_app: option from the call to use the new function. (#116) # server = Server.from_endpoint(Endpoint, otp_app: :my_phoenix_app) server = Server . from_endpoint ( MyPhoenixAppWeb.Endpoint ) Fix: The internal representation of a Phoenix Route struct changed in Phoenix 1.4.7 breaking the OpenApiSpex.Paths.from_router/1 function. OpenApiSpex 3.4.0 will support both representations until the Phoenix API becomes stable. (#118)","ref":"changelog.html#v3-4-0-2019-06-14","title":"Changelog - v3.4.0 - 2019-06-14","type":"extras"},{"doc":"Thanks to the contributions from the community! 👍 hauleth cstaud xadhoom nurugger07 fenollp moxley Feature: Enums expressed as atoms or atom-keyed maps can be cast from strings (or string-keyed maps). (#60) (#101) Example: parameters : [ Operation . parameter ( :sort , :query , :string , &quot;sort direction&quot; , enum : [ :asc , :desc ] ) ] , Fix: Schema module references are resolved in in-line parameter/response schemas. (#77) (#105) Example: The response schema is given in-line as an array, but items are resolved from the User module. responses : %{ 200 =&gt; Operation . response ( &quot;User array&quot; , &quot;application/json&quot; , % Schema { type : :array , items : MyApp.Schemas.User } ) } Fix: Ensure integer query parameters are validated correctly after conversion from string. (#106) Fix: Ensure integers are validated correctly against schema minimum , maximum , exlcusiveMinimum and exclusiveMaximum attributes. (#97) Fix: Ensure strings are cast to Date or DateTime types when the schema format is :date or :date-time . (#90) (#94) Docs: The contract for module supplied to the PutApiSpec plug is now documented by the OpenApi behaviour. (#73) (#103) Docs: Poison replaced with Jason in example and tests (#104) Docs: Improved documentation for combined CastAndValidate plug. (#91) Internals: Cache mapping from phoenix controller/action to OpenApi operation. (#102)","ref":"changelog.html#v3-3-0-2019-05-05","title":"Changelog - v3.3.0 - 2019-05-05","type":"extras"},{"doc":"Patch release for documentation updates and improved error rendering Plug when using CastAndValidate . Thanks moxley ! Cast and validate guide (#89)","ref":"changelog.html#v3-2-1-2019-03-11","title":"Changelog - v3.2.1 - 2019-03-11","type":"extras"},{"doc":"This release contains many improvements and internal changes thanks to the contributions of the community! moxley kpanic hauleth nurugger07 ggpasqualino teamon bryannaegele Feature: Send Plug CSRF token in x-csrf-token header from Swagger UI (#82) Feature: Support Jason library for JSON serialization (#75) Feature: Combine casting and validation into a single CastAndValidate Plug (#69) (#86) Feature: Improved performance by avoiding copying of API Spec data in each request (#83) Fix: Convert integers to float when casting to number type (#81) (#84) Fix: Validate strings without trimming whitespace first (#79) Fix: Exclusive Minimum and Exclusive maximum are validated correctly (#68) Fix: Report errors when unable to convert to the expected number/string/boolean type (#64) Fix: Gracefully report error when failing to convert request params to an object type (#63) Internals: Improved code organisation of unit test suite (#62)","ref":"changelog.html#v3-2-0-2019-03-10","title":"Changelog - v3.2.0 - 2019-03-10","type":"extras"},{"doc":"Add support for validating polymorphic schemas using oneOf , anyOf , allOf , not constructs. Updated example apps to work with new API CI has moved from travis-ci.org to travis-ci.com and now uses github apps integration. Thanks to fenollp and tapickell for contributions!","ref":"changelog.html#v3-1-0-2018-10-28","title":"Changelog - v3.1.0 - 2018-10-28","type":"extras"},{"doc":"Major version bump as the behaviour of OpenApiSpex.Plug.Cast has changed (#39). To enable requests that contain a body as well as path or query params, the result of casting the request body is now placed in the Conn.body_params field, instead of the combined Conn.params field. This requires changing code such as Phoenix controller actions to from def create ( conn , % UserRequest { user : % User { name : name , email : email } } ) do to def create ( conn = %{ body_params : % UserRequest { user : % User { name : name , email : email } } } , params ) do Feature: A custom plug may be provided to render errors (#46) Fix compiler warnings and improve CI process (#53) Fix: Support casting GET requests without Content-Type header (#50, #49) Open API Spex has been moved to the new open-api-spex Github organisation","ref":"changelog.html#v3-0-0-2018-10-25","title":"Changelog - v3.0.0 - 2018-10-25","type":"extras"},{"doc":"Docs: Update example application to include swagger generate mix task (#41) Fix: Ignore charset in content-type header when looking up schema by content type. (#45) Thanks to dmt and fenollp for contributions!","ref":"changelog.html#v2-3-1-2018-09-09","title":"Changelog - v2.3.1 - 2018-09-09","type":"extras"},{"doc":"Feature: Validate string enum types. (#33) Feature: Detect and report missing API spec in OpenApiSpex.Plug.Cast (#37) Fix: Correct atom for parameter style field typespec (#36) Thanks to slavo2 and anagromataf for contributions!","ref":"changelog.html#v2-3-0-2018-08-05","title":"Changelog - v2.3.0 - 2018-08-05","type":"extras"},{"doc":"Feature: Support composite schemas in OpenApiSpex.schema structs defined with OpenApiSpex.schema will include all properties defined in schemas listed in allOf . See the OpenApiSpex.Schema docs for some examples. Feature: Support composite and polymorphic schemas with OpenApiSpex.cast/3 . discriminator is used to cast polymorphic shemas to a more specific schema. allOf will cast all properties in each included schema oneOf / anyOf will attempt to use each schema until a successful cast is made","ref":"changelog.html#v2-2-0-2018-07-07","title":"Changelog - v2.2.0 - 2018-07-07","type":"extras"},{"doc":"Fix: (#24, #25) Operations that define parameters and a requestBody schema can be validated.","ref":"changelog.html#v2-1-1-2018-06-12","title":"Changelog - v2.1.1 - 2018-06-12","type":"extras"},{"doc":"Feature: (#16) Error response from OpenApiSpex.cast when value contains unknown properties and schema declares additionalProperties: false . Feature: (#20) Update swagger-ui to version 3.17.0. Fix: (#17, #21, #22) Update typespecs for struct types.","ref":"changelog.html#v2-1-0-2018-06-08","title":"Changelog - v2.1.0 - 2018-06-08","type":"extras"},{"doc":"Major version update following from API change in OpenApiSpex.cast and OpenApiSpex.validate . When casting/validating all parameters against an OpenApiSpex.Operation , the complete Plug.Conn struct must now be passed, where the combined params map was previously accepted. This allows OpenApiSpex.cast / OpenApiSpex.validate to check that the parameters are being supplied in the expected location (query, path, body, header, cookie). In version 2.0.0, only unexpected query parameters will cause a 422 response from OpenApiSpex.Plug.Cast , this may be extended in future versions to detect more invalid requests. Thanks cstaud , rutho , anagromataf for contributions! Change: (#9) swagger-ui updated to 3.13.4 Change (#9) Unexpected query parameters will produce an error response from OpenApiSpex.Plug.Cast Change: (#9) OpenApiSpex.cast/4 now requires a complete Plug.Conn struct when casting all parameters of an OpenApiSpex.Operation Change: (#14) OpenApiSpex.validate/4 now requires a complete Plug.Conn struct when validating all parameters of an OpenApiSpex.Operation Fix: (#11) Support resolving list of schema modules in oneOf , anyOf , etc. Fix: OpenApiSpex.schema macro allows defining schemas without any properties Fix: type declarations better reflect when nil is allowed","ref":"changelog.html#v2-0-0-2018-06-06","title":"Changelog - v2.0.0 - 2018-06-06","type":"extras"},{"doc":"additionalProperties is now nil by default, was previously true","ref":"changelog.html#v1-1-4-2018-01-21","title":"Changelog - v1.1.4 - 2018-01-21","type":"extras"},{"doc":"Fix several bugs and make some minor enhancements to schema casting and validating. Add sample application to enable end-to-end testing","ref":"changelog.html#v1-1-3-2017-10-15","title":"Changelog - v1.1.3 - 2017-10-15","type":"extras"},{"doc":"Fix openapi version output in generated spec.","ref":"changelog.html#v1-1-2-2017-10-15","title":"Changelog - v1.1.2 - 2017-10-15","type":"extras"},{"doc":"Update swagger-ui to version 3.3.2","ref":"changelog.html#v1-1-1-2017-10-15","title":"Changelog - v1.1.1 - 2017-10-15","type":"extras"},{"doc":"Include path to invalid element in validation errors. Eg: &quot;#/user/name: Value does not match pattern: [a-zA-Z][a-za-z0-9_]+&quot;","ref":"changelog.html#v1-1-0-2017-10-15","title":"Changelog - v1.1.0 - 2017-10-15","type":"extras"},{"doc":"Cache API spec in application environment after first call to PutApiSpec plug","ref":"changelog.html#v1-0-1-2017-10-12","title":"Changelog - v1.0.1 - 2017-10-12","type":"extras"},{"doc":"Initial release. This package is inspired by phoenix_swagger but targets Open API Spec 3.0.","ref":"changelog.html#v1-0-0-2017-10-02","title":"Changelog - v1.0.0 - 2017-10-02","type":"extras"},{"doc":"","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"If you've found a bug or would like to discuss a new feature, start by opening an issue . Where possible, please refer to the relevant sections of the Open API Specification 3.0 or JSON Schema Specification: https://swagger.io/docs/specification/ https://github.com/OAI/OpenAPI-Specification/blob/OpenAPI.next/versions/3.0.0.md https://json-schema.org/understanding-json-schema/","ref":"contributing.html#open-an-issue","title":"Contributing - Open an issue","type":"extras"},{"doc":"Link your pull request to the issue opened earlier, eg fixes #123 . Please be patient as maintainers are generally volunteering their time to support the project 🙂","ref":"contributing.html#send-a-pull-request","title":"Contributing - Send a Pull Request","type":"extras"},{"doc":"You can ask for help using OpenApiSpex by: Opening an issue - you may have run in to a bug or poorly documented feature! Using the open_api_spex slack channel Using the Elixir Forum thread","ref":"contributing.html#get-help","title":"Contributing - Get Help","type":"extras"},{"doc":"To ship a release to Hex.pm, complete the following checklist: Confirm the project builds and all tests pass on your machine mix clean; mix test If possible, look for regressions by testing master against a project that uses :open_api_spex . Confirm the docs build successfully and do not contain obvious formatting errors mix docs; open doc/index.html Review the CHANGELOG.md file, adding a line for each pr / issue and a larger description for significant changes. Update the @version attribute in mix.exs Update the Installation section of the README.md file with the new version (for minor and major releases) Commit and tag the master branch with the version and a leading v , eg: v3.14.15 Push master branch to open_api_spex repo Push package to Hex: mix hex.publish Add a release announcement to the Elixir Forum thread Add a release announcement to the #open_api_spex channel in the Elixir Slack workspace","ref":"contributing.html#releasing-maintainers-only","title":"Contributing - Releasing (Maintainers Only)","type":"extras"},{"doc":"","ref":"roadmap.html","title":"Roadmap","type":"extras"},{"doc":"Remove need for json_render_error_v2: true option for CastAndValidate Remove OpenApiSpex.Plug.Cast , and rename Cast2 to Cast . Simplify interface for error rendering modules Pass casted request params to conn without breaking contract with Conn.t Remove @derive call in OpenApiSpex.schema/1","ref":"roadmap.html#version-4","title":"Roadmap - Version 4","type":"extras"},{"doc":"Mozilla Public License, version 2.0 1. Definitions 1.1. &quot;Contributor&quot; means each individual or legal entity that creates, contributes to the creation of, or owns Covered Software. 1.2. &quot;Contributor Version&quot; means the combination of the Contributions of others (if any) used by a Contributor and that particular Contributor's Contribution. 1.3. &quot;Contribution&quot; means Covered Software of a particular Contributor. 1.4. &quot;Covered Software&quot; means Source Code Form to which the initial Contributor has attached the notice in Exhibit A, the Executable Form of such Source Code Form, and Modifications of such Source Code Form, in each case including portions thereof. 1.5. &quot;Incompatible With Secondary Licenses&quot; means a. that the initial Contributor has attached the notice described in Exhibit B to the Covered Software; or b. that the Covered Software was made available under the terms of version 1.1 or earlier of the License, but not also under the terms of a Secondary License. 1.6. &quot;Executable Form&quot; means any form of the work other than Source Code Form. 1.7. &quot;Larger Work&quot; means a work that combines Covered Software with other material, in a separate file or files, that is not Covered Software. 1.8. &quot;License&quot; means this document. 1.9. &quot;Licensable&quot; means having the right to grant, to the maximum extent possible, whether at the time of the initial grant or subsequently, any and all of the rights conveyed by this License. 1.10. &quot;Modifications&quot; means any of the following: a. any file in Source Code Form that results from an addition to, deletion from, or modification of the contents of Covered Software; or b. any new file in Source Code Form that contains any Covered Software. 1.11. &quot;Patent Claims&quot; of a Contributor means any patent claim(s), including without limitation, method, process, and apparatus claims, in any patent Licensable by such Contributor that would be infringed, but for the grant of the License, by the making, using, selling, offering for sale, having made, import, or transfer of either its Contributions or its Contributor Version. 1.12. &quot;Secondary License&quot; means either the GNU General Public License, Version 2.0, the GNU Lesser General Public License, Version 2.1, the GNU Affero General Public License, Version 3.0, or any later versions of those licenses. 1.13. &quot;Source Code Form&quot; means the form of the work preferred for making modifications. 1.14. &quot;You&quot; (or &quot;Your&quot;) means an individual or a legal entity exercising rights under this License. For legal entities, &quot;You&quot; includes any entity that controls, is controlled by, or is under common control with You. For purposes of this definition, &quot;control&quot; means (a) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (b) ownership of more than fifty percent (50%) of the outstanding shares or beneficial ownership of such entity. 2. License Grants and Conditions 2.1. Grants Each Contributor hereby grants You a world-wide, royalty-free, non-exclusive license: a. under intellectual property rights (other than patent or trademark) Licensable by such Contributor to use, reproduce, make available, modify, display, perform, distribute, and otherwise exploit its Contributions, either on an unmodified basis, with Modifications, or as part of a Larger Work; and b. under Patent Claims of such Contributor to make, use, sell, offer for sale, have made, import, and otherwise transfer either its Contributions or its Contributor Version. 2.2. Effective Date The licenses granted in Section 2.1 with respect to any Contribution become effective for each Contribution on the date the Contributor first distributes such Contribution. 2.3. Limitations on Grant Scope The licenses granted in this Section 2 are the only rights granted under this License. No additional rights or licenses will be implied from the distribution or licensing of Covered Software under this License. Notwithstanding Section 2.1(b) above, no patent license is granted by a Contributor: a. for any code that a Contributor has removed from Covered Software; or b. for infringements caused by: (i) Your and any other third party's modifications of Covered Software, or (ii) the combination of its Contributions with other software (except as part of its Contributor Version); or c. under Patent Claims infringed by Covered Software in the absence of its Contributions. This License does not grant any rights in the trademarks, service marks, or logos of any Contributor (except as may be necessary to comply with the notice requirements in Section 3.4). 2.4. Subsequent Licenses No Contributor makes additional grants as a result of Your choice to distribute the Covered Software under a subsequent version of this License (see Section 10.2) or under the terms of a Secondary License (if permitted under the terms of Section 3.3). 2.5. Representation Each Contributor represents that the Contributor believes its Contributions are its original creation(s) or it has sufficient rights to grant the rights to its Contributions conveyed by this License. 2.6. Fair Use This License is not intended to limit any rights You have under applicable copyright doctrines of fair use, fair dealing, or other equivalents. 2.7. Conditions Sections 3.1, 3.2, 3.3, and 3.4 are conditions of the licenses granted in Section 2.1. 3. Responsibilities 3.1. Distribution of Source Form All distribution of Covered Software in Source Code Form, including any Modifications that You create or to which You contribute, must be under the terms of this License. You must inform recipients that the Source Code Form of the Covered Software is governed by the terms of this License, and how they can obtain a copy of this License. You may not attempt to alter or restrict the recipients' rights in the Source Code Form. 3.2. Distribution of Executable Form If You distribute Covered Software in Executable Form then: a. such Covered Software must also be made available in Source Code Form, as described in Section 3.1, and You must inform recipients of the Executable Form how they can obtain a copy of such Source Code Form by reasonable means in a timely manner, at a charge no more than the cost of distribution to the recipient; and b. You may distribute such Executable Form under the terms of this License, or sublicense it under different terms, provided that the license for the Executable Form does not attempt to limit or alter the recipients' rights in the Source Code Form under this License. 3.3. Distribution of a Larger Work You may create and distribute a Larger Work under terms of Your choice, provided that You also comply with the requirements of this License for the Covered Software. If the Larger Work is a combination of Covered Software with a work governed by one or more Secondary Licenses, and the Covered Software is not Incompatible With Secondary Licenses, this License permits You to additionally distribute such Covered Software under the terms of such Secondary License(s), so that the recipient of the Larger Work may, at their option, further distribute the Covered Software under the terms of either this License or such Secondary License(s). 3.4. Notices You may not remove or alter the substance of any license notices (including copyright notices, patent notices, disclaimers of warranty, or limitations of liability) contained within the Source Code Form of the Covered Software, except that You may alter any license notices to the extent required to remedy known factual inaccuracies. 3.5. Application of Additional Terms You may choose to offer, and to charge a fee for, warranty, support, indemnity or liability obligations to one or more recipients of Covered Software. However, You may do so only on Your own behalf, and not on behalf of any Contributor. You must make it absolutely clear that any such warranty, support, indemnity, or liability obligation is offered by You alone, and You hereby agree to indemnify every Contributor for any liability incurred by such Contributor as a result of warranty, support, indemnity or liability terms You offer. You may include additional disclaimers of warranty and limitations of liability specific to any jurisdiction. 4. Inability to Comply Due to Statute or Regulation If it is impossible for You to comply with any of the terms of this License with respect to some or all of the Covered Software due to statute, judicial order, or regulation then You must: (a) comply with the terms of this License to the maximum extent possible; and (b) describe the limitations and the code they affect. Such description must be placed in a text file included with all distributions of the Covered Software under this License. Except to the extent prohibited by statute or regulation, such description must be sufficiently detailed for a recipient of ordinary skill to be able to understand it. 5. Termination 5.1. The rights granted under this License will terminate automatically if You fail to comply with any of its terms. However, if You become compliant, then the rights granted under this License from a particular Contributor are reinstated (a) provisionally, unless and until such Contributor explicitly and finally terminates Your grants, and (b) on an ongoing basis, if such Contributor fails to notify You of the non-compliance by some reasonable means prior to 60 days after You have come back into compliance. Moreover, Your grants from a particular Contributor are reinstated on an ongoing basis if such Contributor notifies You of the non-compliance by some reasonable means, this is the first time You have received notice of non-compliance with this License from such Contributor, and You become compliant prior to 30 days after Your receipt of the notice. 5.2. If You initiate litigation against any entity by asserting a patent infringement claim (excluding declaratory judgment actions, counter-claims, and cross-claims) alleging that a Contributor Version directly or indirectly infringes any patent, then the rights granted to You by any and all Contributors for the Covered Software under Section 2.1 of this License shall terminate. 5.3. In the event of termination under Sections 5.1 or 5.2 above, all end user license agreements (excluding distributors and resellers) which have been validly granted by You or Your distributors under this License prior to termination shall survive termination. 6. Disclaimer of Warranty Covered Software is provided under this License on an &quot;as is&quot; basis, without warranty of any kind, either expressed, implied, or statutory, including, without limitation, warranties that the Covered Software is free of defects, merchantable, fit for a particular purpose or non-infringing. The entire risk as to the quality and performance of the Covered Software is with You. Should any Covered Software prove defective in any respect, You (not any Contributor) assume the cost of any necessary servicing, repair, or correction. This disclaimer of warranty constitutes an essential part of this License. No use of any Covered Software is authorized under this License except under this disclaimer. 7. Limitation of Liability Under no circumstances and under no legal theory, whether tort (including negligence), contract, or otherwise, shall any Contributor, or anyone who distributes Covered Software as permitted above, be liable to You for any direct, indirect, special, incidental, or consequential damages of any character including, without limitation, damages for lost profits, loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses, even if such party shall have been informed of the possibility of such damages. This limitation of liability shall not apply to liability for death or personal injury resulting from such party's negligence to the extent applicable law prohibits such limitation. Some jurisdictions do not allow the exclusion or limitation of incidental or consequential damages, so this exclusion and limitation may not apply to You. 8. Litigation Any litigation relating to this License may be brought only in the courts of a jurisdiction where the defendant maintains its principal place of business and such litigation shall be governed by laws of that jurisdiction, without reference to its conflict-of-law provisions. Nothing in this Section shall prevent a party's ability to bring cross-claims or counter-claims. 9. Miscellaneous This License represents the complete agreement concerning the subject matter hereof. If any provision of this License is held to be unenforceable, such provision shall be reformed only to the extent necessary to make it enforceable. Any law or regulation which provides that the language of a contract shall be construed against the drafter shall not be used to construe this License against a Contributor. 10. Versions of the License 10.1. New Versions Mozilla Foundation is the license steward. Except as provided in Section 10.3, no one other than the license steward has the right to modify or publish new versions of this License. Each version will be given a distinguishing version number. 10.2. Effect of New Versions You may distribute the Covered Software under the terms of the version of the License under which You originally received the Covered Software, or under the terms of any subsequent version published by the license steward. 10.3. Modified Versions If you create software not governed by this License, and you want to create a new license for such software, you may create and use a modified version of this License if you rename the license and remove any references to the name of the license steward (except to note that such modified license differs from this License). 10.4. Distributing Source Code Form that is Incompatible With Secondary Licenses If You choose to distribute Source Code Form that is Incompatible With Secondary Licenses under the terms of this version of the License, the notice described in Exhibit B of this License must be attached. Exhibit A - Source Code Form License Notice This Source Code Form is subject to the terms of the Mozilla Public License, v. 2.0. If a copy of the MPL was not distributed with this file, You can obtain one at http://mozilla.org/MPL/2.0/. If it is not possible or desirable to put the notice in a particular file, then You may include the notice in a location (such as a LICENSE file in a relevant directory) where a recipient would be likely to look for such a notice. You may add additional accurate notices of copyright ownership. Exhibit B - &quot;Incompatible With Secondary Licenses&quot; Notice This Source Code Form is &quot;Incompatible With Secondary Licenses&quot;, as defined by the Mozilla Public License, v. 2.0.","ref":"license.html","title":"License","type":"extras"},{"doc":"Leverage Open API Specification 3 (formerly Swagger) to document, test, validate and explore your Plug and Phoenix APIs. Generate and serve a JSON Open API Spec document from your code Use the spec to cast request params to well defined schema structs Validate params against schemas, eliminate bad requests before they hit your controllers Validate responses against schemas in tests, ensuring your docs are accurate and reliable Explore the API interactively with SwaggerUI Full documentation available on HexDocs .","ref":"readme.html","title":"Open API Spex","type":"extras"},{"doc":"The package can be installed by adding :open_api_spex to your list of dependencies in mix.exs : def deps do [ { :open_api_spex , &quot;~&gt; 3.20&quot; } ] end","ref":"readme.html#installation","title":"Open API Spex - Installation","type":"extras"},{"doc":"Main Spec Start by adding an ApiSpec module to your application to populate an OpenApiSpex.OpenApi struct. defmodule MyAppWeb.ApiSpec do alias OpenApiSpex . { Components , Info , OpenApi , Paths , Server } alias MyAppWeb . { Endpoint , Router } @behaviour OpenApi @impl OpenApi def spec do % OpenApi { servers : [ # Populate the Server info from a phoenix endpoint Server . from_endpoint ( Endpoint ) ] , info : % Info { title : &quot;My App&quot; , version : &quot;1.0&quot; } , # Populate the paths from a phoenix router paths : Paths . from_router ( Router ) } |&gt; OpenApiSpex . resolve_schema_modules ( ) # Discover request/response schemas from path specs end end Or you can use your application's spec values in the info: key. info : % Info { title : to_string ( Application . spec ( :my_app , :description ) ) , version : to_string ( Application . spec ( :my_app , :vsn ) ) } Authorization In case your API requires authorization you can add security schemes as part of the components in the main spec. components : % Components { securitySchemes : %{ &quot;authorization&quot; =&gt; % SecurityScheme { type : &quot;http&quot; , scheme : &quot;bearer&quot; } } } Once the security scheme is defined you can declare it. Please note that the key below matches the one defined in the security scheme, in the our example, &quot;authorization&quot; . security : [ %{ &quot;authorization&quot; =&gt; [ ] } ] If you require authorization for all endpoints you can declare the security in the main spec. In case you need authorization only for specific endpoints, or if you are using more than one security scheme, you can declare it as part of each operation. To learn more about the different security schemes please the check the official documentation . Operations For each plug (controller) that will handle API requests, operations need to be defined that the plug/controller will handle. defmodule MyAppWeb.UserController do use MyAppWeb , :controller use OpenApiSpex.ControllerSpecs alias MyAppWeb.Schemas . { UserParams , UserResponse } tags [ &quot;users&quot; ] security [ %{ } , %{ &quot;petstore_auth&quot; =&gt; [ &quot;write:users&quot; , &quot;read:users&quot; ] } ] operation :update , summary : &quot;Update user&quot; , parameters : [ id : [ in : :path , description : &quot;User ID&quot; , type : :integer , example : 1001 ] ] , request_body : { &quot;User params&quot; , &quot;application/json&quot; , UserParams } , responses : [ ok : { &quot;User response&quot; , &quot;application/json&quot; , UserResponse } ] def update ( conn , %{ &quot;id&quot; =&gt; id } ) do json ( conn , %{ data : %{ id : id , name : &quot;joe user&quot; , email : &quot;joe@gmail.com&quot; } } ) end end Note: In order to prevent Elixir Formatter from automatically adding parentheses to the ControllerSpecs macro call arguments, add :open_api_spex to the import_deps list in .formatter.exs : .formatter.exs: [ import_deps : [ :open_api_spex ] ] For further information about defining operations, see OpenApiSpex.ControllerSpecs . If you need to omit the spec for some action then pass false to the second argument of operation/2 for the action: operation :create , false Each definition in a controller action or plug operation is converted to an %OpenApiSpex.Operation{} struct. The definitions are read by your application's ApiSpec module, which in turn is called from the OpenApiSpex.Plug.PutApiSpex plug on each request. The definitions data is cached, so it does not actually extract the definitions on each request. Note that the names of the OpenAPI fields follow snake_case naming convention instead of OpenAPI's (and JSON Schema's) camelCase convention. Alternatives to ControllerSpecs-style Operation Specs %Operation{} If ControllerSpecs-style operation specs don't provide the flexibility you need, the %Operation{} struct and related structs can be used instead. See the example user controller that uses %Operation{} structs . For examples of other action operations, see the example web app . Schemas Next, declare JSON schema modules for the request and response bodies. In each schema module, call OpenApiSpex.schema/1 , passing the schema definition. The schema must have keys described in OpenApiSpex.Schema.t . This will define a %OpenApiSpex.Schema{} struct. This struct is made available from the schema/0 public function, which is generated by OpenApiSpex.schema/1 . You may optionally have the data described by the schema turned into a struct linked to the JSON schema by adding &quot;x-struct&quot;: __MODULE__ to the schema. defmodule MyAppWeb.Schemas do alias OpenApiSpex.Schema defmodule User do require OpenApiSpex OpenApiSpex . schema ( %{ # The title is optional. It defaults to the last section of the module name. # So the derived title for MyApp.User is &quot;User&quot;. title : &quot;User&quot; , description : &quot;A user of the app&quot; , type : :object , properties : %{ id : % Schema { type : :integer , description : &quot;User ID&quot; } , name : % Schema { type : :string , description : &quot;User name&quot; , pattern : ~r/[a-zA-Z][a-zA-Z0-9_]+/ } , email : % Schema { type : :string , description : &quot;Email address&quot; , format : :email } , birthday : % Schema { type : :string , description : &quot;Birth date&quot; , format : :date } , inserted_at : % Schema { type : :string , description : &quot;Creation timestamp&quot; , format : :&quot;date-time&quot; } , updated_at : % Schema { type : :string , description : &quot;Update timestamp&quot; , format : :&quot;date-time&quot; } } , required : [ :name , :email ] , example : %{ &quot;id&quot; =&gt; 123 , &quot;name&quot; =&gt; &quot;Joe User&quot; , &quot;email&quot; =&gt; &quot;joe@gmail.com&quot; , &quot;birthday&quot; =&gt; &quot;1970-01-01T12:34:55Z&quot; , &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot; , &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } } ) end defmodule UserResponse do require OpenApiSpex OpenApiSpex . schema ( %{ title : &quot;UserResponse&quot; , description : &quot;Response schema for single user&quot; , type : :object , properties : %{ data : User } , example : %{ &quot;data&quot; =&gt; %{ &quot;id&quot; =&gt; 123 , &quot;name&quot; =&gt; &quot;Joe User&quot; , &quot;email&quot; =&gt; &quot;joe@gmail.com&quot; , &quot;birthday&quot; =&gt; &quot;1970-01-01T12:34:55Z&quot; , &quot;inserted_at&quot; =&gt; &quot;2017-09-12T12:34:55Z&quot; , &quot;updated_at&quot; =&gt; &quot;2017-09-13T10:11:12Z&quot; } } } ) end end For more examples of schema definitions, see the sample Phoenix app .","ref":"readme.html#generate-spec","title":"Open API Spex - Generate Spec","type":"extras"},{"doc":"To serve the API spec from your application, first add the OpenApiSpex.Plug.PutApiSpec plug somewhere in the pipeline. pipeline :api do plug OpenApiSpex.Plug.PutApiSpec , module : MyAppWeb.ApiSpec end Now the spec will be available for use in downstream plugs. The OpenApiSpex.Plug.RenderSpec plug will render the spec as JSON: scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot; , MyAppWeb.UserController , only : [ :create , :index , :show ] get &quot;/openapi&quot; , OpenApiSpex.Plug.RenderSpec , [ ] end In development, to ensure the rendered spec is refreshed, you should disable caching with: # config/dev.exs config :open_api_spex , :cache_adapter , OpenApiSpex.Plug.NoneCache","ref":"readme.html#serve-the-spec","title":"Open API Spex - Serve the Spec","type":"extras"},{"doc":"You can write the swagger file to disk using the following Mix task and optionally, for your convenience, create a direct alias: mix openapi.spec.json --spec MyAppWeb.ApiSpec mix openapi.spec.yaml --spec MyAppWeb.ApiSpec Invoking this task starts the application by default. This can be disabled with the --start-app=false option. Please replace any calls to OpenApiSpex.Server.from_endpoint with a %OpenApiSpex.Server{} struct like below: % OpenApi { info : % Info { title : &quot;Phoenix App&quot; , version : &quot;1.0&quot; } , # Replace this 👇 servers : [ OpenApiSpex.Server . from_endpoint ( MyAppWeb.Endpoint ) ] , # With this 👇 servers : [ % OpenApiSpex.Server { url : &quot;https://yourapi.example.com&quot; } ] , } NOTE: You need to add the ymlr dependency to write swagger file in YAML format: def deps do [ { :ymlr , &quot;~&gt; 2.0&quot; } ] end For more options read the docs . mix help openapi.spec.json mix help openapi.spec.yaml","ref":"readme.html#generating-the-spec","title":"Open API Spex - Generating the Spec","type":"extras"},{"doc":"Once your API spec is available through a route (see &quot;Serve the Spec&quot; ), the OpenApiSpex.Plug.SwaggerUI plug can be used to serve a SwaggerUI interface. The path: plug option must be supplied to give the path to the API spec. All JavaScript and CSS assets are sourced from cdnjs.cloudflare.com, rather than vendoring into this package. scope &quot;/&quot; do pipe_through :browser # Use the default browser stack get &quot;/&quot; , MyAppWeb.PageController , :index get &quot;/swaggerui&quot; , OpenApiSpex.Plug.SwaggerUI , path : &quot;/api/openapi&quot; end scope &quot;/api&quot; do pipe_through :api resources &quot;/users&quot; , MyAppWeb.UserController , only : [ :create , :index , :show ] get &quot;/openapi&quot; , OpenApiSpex.Plug.RenderSpec , [ ] end","ref":"readme.html#serve-swagger-ui","title":"Open API Spex - Serve Swagger UI","type":"extras"},{"doc":":warning: This functionality currently converts Strings into Atoms, which makes it potentially vulnerable to DoS attacks . We recommend that you load Open API Schemas from known files during application startup and not dynamically from external sources at runtime . OpenApiSpex has functionality to import an existing schema, casting it into an %OpenApi{} struct. This means you can load a schema that is JSON or YAML encoded. See the example below: # Importing an existing JSON encoded schema open_api_spec_from_json = &quot;encoded_schema.json&quot; |&gt; File . read! ( ) |&gt; Jason . decode! ( ) |&gt; OpenApiSpex.OpenApi.Decode . decode ( ) # Importing an existing YAML encoded schema open_api_spec_from_yaml = &quot;encoded_schema.yaml&quot; |&gt; YamlElixir . read_all_from_file! ( ) |&gt; List . first ( ) |&gt; OpenApiSpex.OpenApi.Decode . decode ( ) You can then use the loaded spec to with OpenApiSpex.cast_and_validate/3 , like: { :ok , _ } = OpenApiSpex . cast_and_validate ( open_api_spec_from_json , # or open_api_spec_from_yaml spec . paths [ &quot;/some_path&quot; ] . post , test_conn )","ref":"readme.html#importing-an-existing-schema-file","title":"Open API Spex - Importing an existing schema file","type":"extras"},{"doc":"OpenApiSpex can automatically validate requests before they reach the controller action function. Or if you prefer, you can explicitly call on OpenApiSpex to cast and validate the params within the controller action. See OpenApiSpex.cast_value/3 for the latter. The rest of this section describes implicit casting and validating the request before it reaches your controller action. First, the plug OpenApiSpex.Plug.PutApiSpec needs to be called in the Router, as described above. Add the OpenApiSpex.Plug.CastAndValidate plug to a controller to validate request parameters and to cast to Elixir types defined by the operation schema. # Phoenix plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true # Plug plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true , operation_id : &quot;UserController.create&quot; The json_render_error_v2: true is a work-around for a bug in the format of the default error renderer. It will be not needed in version 4.0. For Phoenix apps, the operation_id can be inferred from the contents of conn.private . The data shape of the default error renderer follows the JSON:API spec for error responses. For convenience, the OpenApiSpex.JsonErrorResponse schema module is available that specifies the shape, and it can be used in your API specs. Example usage of CastAndValidate in a Phoenix controller: defmodule MyAppWeb.UserController do use MyAppWeb , :controller use OpenApiSpex.ControllerSpecs alias MyAppWeb.Schemas . { UserParams , UserResponse } plug OpenApiSpex.Plug.CastAndValidate , json_render_error_v2 : true operation :update , summary : &quot;Update user&quot; , description : &quot;Updates with the given params. \\n This is another line of text in the description.&quot; , parameters : [ id : [ in : :path , type : :integer , description : &quot;user ID&quot; ] , vsn : [ in : :query , type : :integer , description : &quot;API version number&quot; ] , &quot;api-version&quot; : [ in : :header , type : :integer , description : &quot;API version number&quot; ] ] , request_body : { &quot;The user attributes&quot; , &quot;application/json&quot; , UserParams } , responses : %{ 201 =&gt; { &quot;User&quot; , &quot;application/json&quot; , UserResponse } , 422 =&gt; OpenApiSpex.JsonErrorResponse . response ( ) } def update ( conn = %{ body_params : % UserParams { name : name , email : email , birthday : % Date { } = birthday } } , %{ id : id } ) do # conn.body_params cast to UserRequest struct # conn.params combines path params, query params and header params # conn.params.id cast to integer # conn.params.vsn cast to integer # conn.params[:&quot;api-version&quot;] cast to integer # params is the same as conn.params # params.id cast to integer # Note: Using pattern-matching in the action function&#39;s arguments can # cause Dialyzer to complain. This is because Dialyzer expects the # `conn` and `params` arguments to have string keys, not atom keys. # To resolve this, fetch the `:body_params` with # `body_params = Map.get(conn, :body_params)`. end end Now the client will receive a 422 response whenever the request fails to meet the validation rules from the api spec. The response body will include the validation error message: { &quot;errors&quot;: [ { &quot;detail&quot;: &quot;Invalid format. Expected :date&quot;, &quot;source&quot;: { &quot;pointer&quot;: &quot;/data/birthday&quot; }, &quot;title&quot;: &quot;Invalid value&quot; } ] } If you would like a different response JSON shape, create a plug module to shape the response, and pass it to CastAndValidate : plug OpenApiSpex.Plug.CastAndValidate , render_error : MyErrorRendererPlug defmodule MyErrorRendererPlug do @behaviour Plug alias Plug.Conn alias OpenApiSpex.OpenApi @impl Plug def init ( errors ) , do : errors @impl Plug def call ( conn , errors ) when is_list ( errors ) do response = %{ errors : Enum . map ( errors , &amp; to_string / 1 ) } json = OpenApi . json_encoder ( ) . encode! ( response ) conn |&gt; Conn . put_resp_content_type ( &quot;application/json&quot; ) |&gt; Conn . send_resp ( 422 , json ) end end","ref":"readme.html#validating-and-casting-params","title":"Open API Spex - Validating and Casting Params","type":"extras"},{"doc":"OpenApiSpex can generate example data from specs. This has a similar result as SwaggerUI when it generates example requests or responses for an endpoint. This is a convenient way to generate test data for controller/plug tests. use MyAppWeb.ConnCase test &quot;create/2&quot; , %{ conn : conn } do request_body = OpenApiSpex.Schema . example ( MyAppWeb.Schemas.UserRequest . schema ( ) ) json = conn |&gt; post ( user_path ( conn ) , request_body ) |&gt; json_response ( 200 ) end","ref":"readme.html#generate-examples","title":"Open API Spex - Generate Examples","type":"extras"},{"doc":"As schemas evolve, you may want to confirm that the examples given match the schemas. Use the OpenApiSpex.TestAssertions module to assert on schema validations. use ExUnit.Case import OpenApiSpex.TestAssertions test &quot;UsersResponse example matches schema&quot; do api_spec = MyAppWeb.ApiSpec . spec ( ) schema = MyAppWeb.Schemas.UsersResponse . schema ( ) assert_schema ( schema . example , &quot;UsersResponse&quot; , api_spec ) end","ref":"readme.html#validate-examples","title":"Open API Spex - Validate Examples","type":"extras"},{"doc":"API responses can be tested against schemas using OpenApiSpex.TestAssertions also: use MyAppWeb.ConnCase import OpenApiSpex.TestAssertions test &quot;UserController produces a UsersResponse&quot; , %{ conn : conn } do json = conn |&gt; get ( user_path ( conn , :index ) ) |&gt; json_response ( 200 ) api_spec = MyAppWeb.ApiSpec . spec ( ) assert_schema ( json , &quot;UsersResponse&quot; , api_spec ) end","ref":"readme.html#validate-responses","title":"Open API Spex - Validate Responses","type":"extras"},{"doc":"Copyright (c) 2017 Michael Buhot Licensed under the Mozilla Public License, Version 2.0, which can be found in LICENSE .","ref":"readme.html#copyright-and-license","title":"Open API Spex - Copyright and License","type":"extras"}]